/*
 * Qcint is a general GTO integral library for computational chemistry
 * Copyright (C) 2014- Qiming Sun <osirpt.sun@gmail.com>
 *
 * This file is part of Qcint.
 *
 * Qcint is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Description: code generated by  gen-code.cl
 */
#include <stdlib.h>
#include "cint_bas.h"
#include "simd.h"
#include "cart2sph.h"
#include "g1e.h"
#include "g2e.h"
#include "optimizer.h"
#include "cint1e.h"
#include "cint2e.h"
#include "misc.h"
#include "c2f.h"
/* <i|OVLP |SIGMA j> */
void CINTgout1e_int1e_sigma(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 12;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
__MD r1;
__MD rs[1];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
r1 = - rs[0]; GOUT_SCATTER(gout, n*12+0, r1);
GOUT_SCATTER(gout, n*12+1, MM_SET1(0.));
GOUT_SCATTER(gout, n*12+2, MM_SET1(0.));
GOUT_SCATTER(gout, n*12+3, MM_SET1(0.));
GOUT_SCATTER(gout, n*12+4, MM_SET1(0.));
r1 = - rs[0]; GOUT_SCATTER(gout, n*12+5, r1);
GOUT_SCATTER(gout, n*12+6, MM_SET1(0.));
GOUT_SCATTER(gout, n*12+7, MM_SET1(0.));
GOUT_SCATTER(gout, n*12+8, MM_SET1(0.));
GOUT_SCATTER(gout, n*12+9, MM_SET1(0.));
r1 = - rs[0]; GOUT_SCATTER(gout, n*12+10, r1);
GOUT_SCATTER(gout, n*12+11, MM_SET1(0.));
}}
void int1e_sigma_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {0, 0, 0, 0, 0, 4, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_sigma_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 0, 0, 0, 0, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sigma;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_sigma_cart
int int1e_sigma_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 0, 0, 0, 0, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sigma;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_sigma_sph
int int1e_sigma_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 0, 0, 0, 0, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sigma;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_sigma_spinor
ALL_CINT1E(int1e_sigma)
//ALL_CINT1E_FORTRAN_(cint1e_sigma)
/* <SIGMA DOT P i|OVLP |SIGMA SIGMA DOT P j> */
void CINTgout1e_int1e_spsigmasp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 12;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
r1 = - rs[0] + rs[8] + rs[4]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = + MM_SET1(-2)*rs[3]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = + MM_SET1(-2)*rs[6]; GOUT_SCATTER(gout, n*12+2, r1);
GOUT_SCATTER(gout, n*12+3, MM_SET1(0.));
r1 = + MM_SET1(-2)*rs[1]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = - rs[4] + rs[0] + rs[8]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = + MM_SET1(-2)*rs[7]; GOUT_SCATTER(gout, n*12+6, r1);
GOUT_SCATTER(gout, n*12+7, MM_SET1(0.));
r1 = + MM_SET1(-2)*rs[2]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = + MM_SET1(-2)*rs[5]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = - rs[8] + rs[4] + rs[0]; GOUT_SCATTER(gout, n*12+10, r1);
GOUT_SCATTER(gout, n*12+11, MM_SET1(0.));
}}
void int1e_spsigmasp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_spsigmasp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spsigmasp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_spsigmasp_cart
int int1e_spsigmasp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spsigmasp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_spsigmasp_sph
int int1e_spsigmasp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spsigmasp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_spsigmasp_spinor
ALL_CINT1E(int1e_spsigmasp)
//ALL_CINT1E_FORTRAN_(cint1e_spsigmasp)
/* <SIGMA DOT R i|OVLP |SIGMA DOT R j> */
void CINTgout1e_int1e_srsr(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 4;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G1E_R_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_R_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
r1 = + rs[5] - rs[7]; GOUT_SCATTER(gout, n*4+0, r1);
r1 = + rs[6] - rs[2]; GOUT_SCATTER(gout, n*4+1, r1);
r1 = + rs[1] - rs[3]; GOUT_SCATTER(gout, n*4+2, r1);
r1 = + rs[0] + rs[4] + rs[8]; GOUT_SCATTER(gout, n*4+3, r1);
}}
void int1e_srsr_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_srsr_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srsr;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_srsr_cart
int int1e_srsr_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srsr;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_srsr_sph
int int1e_srsr_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srsr;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_srsr_spinor
ALL_CINT1E(int1e_srsr)
//ALL_CINT1E_FORTRAN_(cint1e_srsr)
/* <SIGMA DOT R i|OVLP |j> */
void CINTgout1e_int1e_sr(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 4;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[3];
G1E_R_I(g1, g0, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
r1 = - rs[0]; GOUT_SCATTER(gout, n*4+0, r1);
r1 = - rs[1]; GOUT_SCATTER(gout, n*4+1, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*4+2, r1);
GOUT_SCATTER(gout, n*4+3, MM_SET1(0.));
}}
void int1e_sr_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_sr_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sr;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_sr_cart
int int1e_sr_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sr;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_sr_sph
int int1e_sr_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sr;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_sr_spinor
ALL_CINT1E(int1e_sr)
//ALL_CINT1E_FORTRAN_(cint1e_sr)
/* <SIGMA DOT R i|OVLP |SIGMA DOT P j> */
void CINTgout1e_int1e_srsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 4;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_R_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
r1 = - rs[5] + rs[7]; GOUT_SCATTER(gout, n*4+0, r1);
r1 = - rs[6] + rs[2]; GOUT_SCATTER(gout, n*4+1, r1);
r1 = - rs[1] + rs[3]; GOUT_SCATTER(gout, n*4+2, r1);
r1 = - rs[0] - rs[4] - rs[8]; GOUT_SCATTER(gout, n*4+3, r1);
}}
void int1e_srsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_srsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_srsp_cart
int int1e_srsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_srsp_sph
int int1e_srsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srsp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_srsp_spinor
ALL_CINT1E(int1e_srsp)
//ALL_CINT1E_FORTRAN_(cint1e_srsp)
/* <SIGMA DOT P i|OVLP |SIGMA DOT P j> */
void CINTgout1e_int1e_spsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 1;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
r1 = + rs[0] + rs[4] + rs[8]; GOUT_SCATTER(gout, n*1+0, r1);
}}
void int1e_spsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 1, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_spsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_spsp_cart
int int1e_spsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_spsp_sph
int int1e_spsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 1, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spsp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_1e);
} // int1e_spsp_spinor
ALL_CINT1E(int1e_spsp)
//ALL_CINT1E_FORTRAN_(cint1e_spsp)
/* <SIGMA DOT P i|OVLP |j> */
void CINTgout1e_int1e_sp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 4;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[3];
G1E_D_I(g1, g0, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
r1 = + rs[0]; GOUT_SCATTER(gout, n*4+0, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*4+1, r1);
r1 = + rs[2]; GOUT_SCATTER(gout, n*4+2, r1);
GOUT_SCATTER(gout, n*4+3, MM_SET1(0.));
}}
void int1e_sp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_sp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_sp_cart
int int1e_sp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_sp_sph
int int1e_sp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 4, 1, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_sp_spinor
ALL_CINT1E(int1e_sp)
//ALL_CINT1E_FORTRAN_(cint1e_sp)
/* <SIGMA DOT P i|NUC |SIGMA DOT P j> */
void CINTgout1e_int1e_spnucsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int nfc = nf * 4;
double *gout1 = gout + nfc*SIMDD;
int ix, iy, iz, ia, n, i;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
for (n = 0; n < nfc*SIMDD; n++) { gout1[n] = 0; }
for (ia = 0; ia < envs->natm; ia++) {
CINTg1e_nuc(g, envs, count, ia);
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = MM_LOAD(gout1+(n*4+0)*SIMDD) + + rs[5] - rs[7]; MM_STORE(gout1+(n*4+0)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*4+1)*SIMDD) + + rs[6] - rs[2]; MM_STORE(gout1+(n*4+1)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*4+2)*SIMDD) + + rs[1] - rs[3]; MM_STORE(gout1+(n*4+2)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*4+3)*SIMDD) + + rs[0] + rs[4] + rs[8]; MM_STORE(gout1+(n*4+3)*SIMDD, r1);
}
}
CINTsort_gout(gout, gout1, nfc, SIMDD);
}
void int1e_spnucsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_spnucsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spnucsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_spnucsp_cart
int int1e_spnucsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spnucsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_spnucsp_sph
int int1e_spnucsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spnucsp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_spnucsp_spinor
ALL_CINT1E(int1e_spnucsp)
//ALL_CINT1E_FORTRAN_(cint1e_spnucsp)
/* <SIGMA DOT P i|RINV |SIGMA DOT P j> */
void CINTgout1e_int1e_sprinvsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_nuc(g, envs, count, -1);
int nf = envs->nf;
int nfc = nf * 4;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, n, i;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = + rs[5] - rs[7]; GOUT_SCATTER(gout, n*4+0, r1);
r1 = + rs[6] - rs[2]; GOUT_SCATTER(gout, n*4+1, r1);
r1 = + rs[1] - rs[3]; GOUT_SCATTER(gout, n*4+2, r1);
r1 = + rs[0] + rs[4] + rs[8]; GOUT_SCATTER(gout, n*4+3, r1);
}}
void int1e_sprinvsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_sprinvsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sprinvsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_sprinvsp_cart
int int1e_sprinvsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sprinvsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_sprinvsp_sph
int int1e_sprinvsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sprinvsp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_sprinvsp_spinor
ALL_CINT1E(int1e_sprinvsp)
//ALL_CINT1E_FORTRAN_(cint1e_sprinvsp)
/* <SIGMA DOT R i|NUC |SIGMA DOT R j> */
void CINTgout1e_int1e_srnucsr(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int nfc = nf * 4;
double *gout1 = gout + nfc*SIMDD;
int ix, iy, iz, ia, n, i;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
for (n = 0; n < nfc*SIMDD; n++) { gout1[n] = 0; }
for (ia = 0; ia < envs->natm; ia++) {
CINTg1e_nuc(g, envs, count, ia);
G2E_R_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_R_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_R_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = MM_LOAD(gout1+(n*4+0)*SIMDD) + + rs[5] - rs[7]; MM_STORE(gout1+(n*4+0)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*4+1)*SIMDD) + + rs[6] - rs[2]; MM_STORE(gout1+(n*4+1)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*4+2)*SIMDD) + + rs[1] - rs[3]; MM_STORE(gout1+(n*4+2)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*4+3)*SIMDD) + + rs[0] + rs[4] + rs[8]; MM_STORE(gout1+(n*4+3)*SIMDD, r1);
}
}
CINTsort_gout(gout, gout1, nfc, SIMDD);
}
void int1e_srnucsr_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_srnucsr_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srnucsr;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_srnucsr_cart
int int1e_srnucsr_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srnucsr;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_srnucsr_sph
int int1e_srnucsr_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 1};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_srnucsr;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_srnucsr_spinor
ALL_CINT1E(int1e_srnucsr)
//ALL_CINT1E_FORTRAN_(cint1e_srnucsr)
/* <SIGMA DOT P i|RC |SIGMA DOT P j> */
void CINTgout1e_int1e_sprsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 12;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3  + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4  + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5  + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6  + envs->g_size * 3 * SIMDD;
double drj[3];
drj[0] = envs->rj[0] - envs->env[PTR_COMMON_ORIG+0];
drj[1] = envs->rj[1] - envs->env[PTR_COMMON_ORIG+1];
drj[2] = envs->rj[2] - envs->env[PTR_COMMON_ORIG+2];
__MD r1;
__MD rs[27];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCJ(g2, g0, envs->i_l+1, envs->j_l+1, 0);
G1E_D_J(g3, g2, envs->i_l+1, envs->j_l+0, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g7+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g6+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g6+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g5+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g5+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
rs[9] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[10] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g5+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[11] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[12] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g6+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[13] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g7+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[14] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g6+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[15] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[16] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g5+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[17] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
rs[18] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[19] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[20] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g5+iz*SIMDD);
rs[21] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[22] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[23] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g5+iz*SIMDD);
rs[24] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g6+iz*SIMDD);
rs[25] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g6+iz*SIMDD);
rs[26] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g7+iz*SIMDD);
GOUT_SCATTER(gout, n*12+0, MM_SET1(0.));
r1 = + rs[18] - rs[2]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = + rs[1] - rs[9]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[0] + rs[10] + rs[20]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = + rs[14] - rs[22]; GOUT_SCATTER(gout, n*12+4, r1);
GOUT_SCATTER(gout, n*12+5, MM_SET1(0.));
r1 = + rs[4] - rs[12]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = + rs[3] + rs[13] + rs[23]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = + rs[17] - rs[25]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = + rs[24] - rs[8]; GOUT_SCATTER(gout, n*12+9, r1);
GOUT_SCATTER(gout, n*12+10, MM_SET1(0.));
r1 = + rs[6] + rs[16] + rs[26]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void int1e_sprsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 2, 0, 0, 3, 4, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_sprsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 2, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sprsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_sprsp_cart
int int1e_sprsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 2, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sprsp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_sprsp_sph
int int1e_sprsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 2, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sprsp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_sprsp_spinor
ALL_CINT1E(int1e_sprsp)
//ALL_CINT1E_FORTRAN_(cint1e_sprsp)
/* <G i|OVLP |j> */
void CINTgout1e_int1e_govlp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 3;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
__MD r1;
__MD rs[3];
G1E_R0I(g1, g0, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
r1 = + MM_SET1(c[1])*rs[2] - MM_SET1(c[2])*rs[1]; GOUT_SCATTER(gout, n*3+0, r1);
r1 = + MM_SET1(c[2])*rs[0] - MM_SET1(c[0])*rs[2]; GOUT_SCATTER(gout, n*3+1, r1);
r1 = + MM_SET1(c[0])*rs[1] - MM_SET1(c[1])*rs[0]; GOUT_SCATTER(gout, n*3+2, r1);
}}
void int1e_govlp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_govlp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_govlp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_govlp_cart
int int1e_govlp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_govlp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_govlp_sph
int int1e_govlp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_govlp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_1ei);
} // int1e_govlp_spinor
ALL_CINT1E(int1e_govlp)
//ALL_CINT1E_FORTRAN_(cint1e_govlp)
/* <G i|NUC |j> */
void CINTgout1e_int1e_gnuc(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int nfc = nf * 3;
double *gout1 = gout + nfc*SIMDD;
int ix, iy, iz, ia, n, i;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
__MD r1;
__MD rs[3];
for (n = 0; n < nfc*SIMDD; n++) { gout1[n] = 0; }
for (ia = 0; ia < envs->natm; ia++) {
CINTg1e_nuc(g, envs, count, ia);
G2E_R0I(g1, g0, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 3; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
}
r1 = MM_LOAD(gout1+(n*3+0)*SIMDD) + + MM_SET1(c[1])*rs[2] - MM_SET1(c[2])*rs[1]; MM_STORE(gout1+(n*3+0)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*3+1)*SIMDD) + + MM_SET1(c[2])*rs[0] - MM_SET1(c[0])*rs[2]; MM_STORE(gout1+(n*3+1)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*3+2)*SIMDD) + + MM_SET1(c[0])*rs[1] - MM_SET1(c[1])*rs[0]; MM_STORE(gout1+(n*3+2)*SIMDD, r1);
}
}
CINTsort_gout(gout, gout1, nfc, SIMDD);
}
void int1e_gnuc_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_gnuc_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_gnuc;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_gnuc_cart
int int1e_gnuc_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_gnuc;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_gnuc_sph
int int1e_gnuc_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_gnuc;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_1ei);
} // int1e_gnuc_spinor
ALL_CINT1E(int1e_gnuc)
//ALL_CINT1E_FORTRAN_(cint1e_gnuc)
/* <SIGMA CROSS RC i|SIGMA CROSS NABLA-RINV |j> */
void CINTgout1e_int1e_cg_sa10sa01(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_nuc(g, envs, count, -1);
int nf = envs->nf;
int nfc = nf * 36;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, n, i;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double dri[3];
dri[0] = envs->ri[0] - envs->env[PTR_COMMON_ORIG+0];
dri[1] = envs->ri[1] - envs->env[PTR_COMMON_ORIG+1];
dri[2] = envs->ri[2] - envs->env[PTR_COMMON_ORIG+2];
__MD r1;
__MD rs[9];
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+1, envs->j_l+0, 0, 0);
for (ix = 0; ix < envs->g_size * 3 * SIMDD; ix++) {g1[ix] += g2[ix];}
G2E_RCI(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = - rs[7] + rs[5]; GOUT_SCATTER(gout, n*36+0, r1);
GOUT_SCATTER(gout, n*36+1, MM_SET1(0.));
GOUT_SCATTER(gout, n*36+2, MM_SET1(0.));
r1 = + rs[8] + rs[4]; GOUT_SCATTER(gout, n*36+3, r1);
r1 = + rs[6]; GOUT_SCATTER(gout, n*36+4, r1);
r1 = + rs[5]; GOUT_SCATTER(gout, n*36+5, r1);
r1 = + rs[8]; GOUT_SCATTER(gout, n*36+6, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*36+7, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*36+8, r1);
r1 = - rs[4]; GOUT_SCATTER(gout, n*36+9, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*36+10, r1);
r1 = - rs[6]; GOUT_SCATTER(gout, n*36+11, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*36+12, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*36+13, r1);
r1 = - rs[8]; GOUT_SCATTER(gout, n*36+14, r1);
r1 = - rs[1]; GOUT_SCATTER(gout, n*36+15, r1);
GOUT_SCATTER(gout, n*36+16, MM_SET1(0.));
r1 = - rs[2] + rs[6]; GOUT_SCATTER(gout, n*36+17, r1);
GOUT_SCATTER(gout, n*36+18, MM_SET1(0.));
r1 = + rs[8] + rs[0]; GOUT_SCATTER(gout, n*36+19, r1);
r1 = + rs[0]; GOUT_SCATTER(gout, n*36+20, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*36+21, r1);
r1 = + rs[6]; GOUT_SCATTER(gout, n*36+22, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*36+23, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*36+24, r1);
r1 = + rs[4]; GOUT_SCATTER(gout, n*36+25, r1);
r1 = + rs[5]; GOUT_SCATTER(gout, n*36+26, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*36+27, r1);
r1 = - rs[0]; GOUT_SCATTER(gout, n*36+28, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*36+29, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*36+30, r1);
r1 = - rs[5]; GOUT_SCATTER(gout, n*36+31, r1);
GOUT_SCATTER(gout, n*36+32, MM_SET1(0.));
GOUT_SCATTER(gout, n*36+33, MM_SET1(0.));
r1 = - rs[3] + rs[1]; GOUT_SCATTER(gout, n*36+34, r1);
r1 = + rs[4] + rs[0]; GOUT_SCATTER(gout, n*36+35, r1);
}}
void int1e_cg_sa10sa01_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_cg_sa10sa01_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10sa01;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_cg_sa10sa01_cart
int int1e_cg_sa10sa01_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10sa01;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_cg_sa10sa01_sph
int int1e_cg_sa10sa01_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10sa01;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_cg_sa10sa01_spinor
ALL_CINT1E(int1e_cg_sa10sa01)
//ALL_CINT1E_FORTRAN_(cint1e_cg_sa10sa01)
/* <RC CROSS SIGMA i|OVLP |SIGMA DOT P j> */
void CINTgout1e_int1e_cg_sa10sp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 12;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
double dri[3];
dri[0] = envs->ri[0] - envs->env[PTR_COMMON_ORIG+0];
dri[1] = envs->ri[1] - envs->env[PTR_COMMON_ORIG+1];
dri[2] = envs->ri[2] - envs->env[PTR_COMMON_ORIG+2];
__MD r1;
__MD rs[9];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_RCI(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_RCI(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
r1 = + rs[8] + rs[4]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = - rs[6]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[7] - rs[5]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = - rs[1]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[0] + rs[8]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = - rs[6] + rs[2]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = - rs[5]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[4] + rs[0]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[3] - rs[1]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void int1e_cg_sa10sp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_cg_sa10sp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10sp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_cg_sa10sp_cart
int int1e_cg_sa10sp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10sp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_cg_sa10sp_sph
int int1e_cg_sa10sp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10sp;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_cg_sa10sp_spinor
ALL_CINT1E(int1e_cg_sa10sp)
//ALL_CINT1E_FORTRAN_(cint1e_cg_sa10sp)
/* <RC CROSS SIGMA i|NUC |SIGMA DOT P j> */
void CINTgout1e_int1e_cg_sa10nucsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int nfc = nf * 12;
double *gout1 = gout + nfc*SIMDD;
int ix, iy, iz, ia, n, i;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
double dri[3];
dri[0] = envs->ri[0] - envs->env[PTR_COMMON_ORIG+0];
dri[1] = envs->ri[1] - envs->env[PTR_COMMON_ORIG+1];
dri[2] = envs->ri[2] - envs->env[PTR_COMMON_ORIG+2];
__MD r1;
__MD rs[9];
for (n = 0; n < nfc*SIMDD; n++) { gout1[n] = 0; }
for (ia = 0; ia < envs->natm; ia++) {
CINTg1e_nuc(g, envs, count, ia);
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_RCI(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_RCI(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = MM_LOAD(gout1+(n*12+0)*SIMDD) + + rs[8] + rs[4]; MM_STORE(gout1+(n*12+0)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+1)*SIMDD) + - rs[3]; MM_STORE(gout1+(n*12+1)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+2)*SIMDD) + - rs[6]; MM_STORE(gout1+(n*12+2)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+3)*SIMDD) + + rs[7] - rs[5]; MM_STORE(gout1+(n*12+3)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+4)*SIMDD) + - rs[1]; MM_STORE(gout1+(n*12+4)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+5)*SIMDD) + + rs[0] + rs[8]; MM_STORE(gout1+(n*12+5)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+6)*SIMDD) + - rs[7]; MM_STORE(gout1+(n*12+6)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+7)*SIMDD) + - rs[6] + rs[2]; MM_STORE(gout1+(n*12+7)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+8)*SIMDD) + - rs[2]; MM_STORE(gout1+(n*12+8)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+9)*SIMDD) + - rs[5]; MM_STORE(gout1+(n*12+9)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+10)*SIMDD) + + rs[4] + rs[0]; MM_STORE(gout1+(n*12+10)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+11)*SIMDD) + + rs[3] - rs[1]; MM_STORE(gout1+(n*12+11)*SIMDD, r1);
}
}
CINTsort_gout(gout, gout1, nfc, SIMDD);
}
void int1e_cg_sa10nucsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_cg_sa10nucsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10nucsp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_cg_sa10nucsp_cart
int int1e_cg_sa10nucsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10nucsp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_cg_sa10nucsp_sph
int int1e_cg_sa10nucsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_cg_sa10nucsp;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_cg_sa10nucsp_spinor
ALL_CINT1E(int1e_cg_sa10nucsp)
//ALL_CINT1E_FORTRAN_(cint1e_cg_sa10nucsp)
/* <SIGMA CROSS R i|SIGMA CROSS NABLA-RINV |j> */
void CINTgout1e_int1e_giao_sa10sa01(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_nuc(g, envs, count, -1);
int nf = envs->nf;
int nfc = nf * 36;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, n, i;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+1, envs->j_l+0, 0, 0);
for (ix = 0; ix < envs->g_size * 3 * SIMDD; ix++) {g1[ix] += g2[ix];}
G2E_R_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_R_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = - rs[7] + rs[5]; GOUT_SCATTER(gout, n*36+0, r1);
GOUT_SCATTER(gout, n*36+1, MM_SET1(0.));
GOUT_SCATTER(gout, n*36+2, MM_SET1(0.));
r1 = + rs[8] + rs[4]; GOUT_SCATTER(gout, n*36+3, r1);
r1 = + rs[6]; GOUT_SCATTER(gout, n*36+4, r1);
r1 = + rs[5]; GOUT_SCATTER(gout, n*36+5, r1);
r1 = + rs[8]; GOUT_SCATTER(gout, n*36+6, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*36+7, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*36+8, r1);
r1 = - rs[4]; GOUT_SCATTER(gout, n*36+9, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*36+10, r1);
r1 = - rs[6]; GOUT_SCATTER(gout, n*36+11, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*36+12, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*36+13, r1);
r1 = - rs[8]; GOUT_SCATTER(gout, n*36+14, r1);
r1 = - rs[1]; GOUT_SCATTER(gout, n*36+15, r1);
GOUT_SCATTER(gout, n*36+16, MM_SET1(0.));
r1 = - rs[2] + rs[6]; GOUT_SCATTER(gout, n*36+17, r1);
GOUT_SCATTER(gout, n*36+18, MM_SET1(0.));
r1 = + rs[8] + rs[0]; GOUT_SCATTER(gout, n*36+19, r1);
r1 = + rs[0]; GOUT_SCATTER(gout, n*36+20, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*36+21, r1);
r1 = + rs[6]; GOUT_SCATTER(gout, n*36+22, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*36+23, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*36+24, r1);
r1 = + rs[4]; GOUT_SCATTER(gout, n*36+25, r1);
r1 = + rs[5]; GOUT_SCATTER(gout, n*36+26, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*36+27, r1);
r1 = - rs[0]; GOUT_SCATTER(gout, n*36+28, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*36+29, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*36+30, r1);
r1 = - rs[5]; GOUT_SCATTER(gout, n*36+31, r1);
GOUT_SCATTER(gout, n*36+32, MM_SET1(0.));
GOUT_SCATTER(gout, n*36+33, MM_SET1(0.));
r1 = - rs[3] + rs[1]; GOUT_SCATTER(gout, n*36+34, r1);
r1 = + rs[4] + rs[0]; GOUT_SCATTER(gout, n*36+35, r1);
}}
void int1e_giao_sa10sa01_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_giao_sa10sa01_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10sa01;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_giao_sa10sa01_cart
int int1e_giao_sa10sa01_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10sa01;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_giao_sa10sa01_sph
int int1e_giao_sa10sa01_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10sa01;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_giao_sa10sa01_spinor
ALL_CINT1E(int1e_giao_sa10sa01)
//ALL_CINT1E_FORTRAN_(cint1e_giao_sa10sa01)
/* <R CROSS SIGMA i|OVLP |SIGMA DOT P j> */
void CINTgout1e_int1e_giao_sa10sp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 12;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G1E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0);
G1E_R_I(g2, g0, envs->i_l+0, envs->j_l, 0);
G1E_R_I(g3, g1, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
r1 = + rs[8] + rs[4]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = - rs[6]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[7] - rs[5]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = - rs[1]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[0] + rs[8]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = - rs[6] + rs[2]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = - rs[5]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[4] + rs[0]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[3] - rs[1]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void int1e_giao_sa10sp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_giao_sa10sp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10sp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_giao_sa10sp_cart
int int1e_giao_sa10sp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10sp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_giao_sa10sp_sph
int int1e_giao_sa10sp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10sp;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_giao_sa10sp_spinor
ALL_CINT1E(int1e_giao_sa10sp)
//ALL_CINT1E_FORTRAN_(cint1e_giao_sa10sp)
/* <R CROSS SIGMA i|NUC |SIGMA DOT P j> */
void CINTgout1e_int1e_giao_sa10nucsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int nfc = nf * 12;
double *gout1 = gout + nfc*SIMDD;
int ix, iy, iz, ia, n, i;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
for (n = 0; n < nfc*SIMDD; n++) { gout1[n] = 0; }
for (ia = 0; ia < envs->natm; ia++) {
CINTg1e_nuc(g, envs, count, ia);
G2E_D_J(g1, g0, envs->i_l+1, envs->j_l+0, 0, 0);
G2E_R_I(g2, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_R_I(g3, g1, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = MM_LOAD(gout1+(n*12+0)*SIMDD) + + rs[8] + rs[4]; MM_STORE(gout1+(n*12+0)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+1)*SIMDD) + - rs[3]; MM_STORE(gout1+(n*12+1)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+2)*SIMDD) + - rs[6]; MM_STORE(gout1+(n*12+2)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+3)*SIMDD) + + rs[7] - rs[5]; MM_STORE(gout1+(n*12+3)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+4)*SIMDD) + - rs[1]; MM_STORE(gout1+(n*12+4)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+5)*SIMDD) + + rs[0] + rs[8]; MM_STORE(gout1+(n*12+5)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+6)*SIMDD) + - rs[7]; MM_STORE(gout1+(n*12+6)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+7)*SIMDD) + - rs[6] + rs[2]; MM_STORE(gout1+(n*12+7)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+8)*SIMDD) + - rs[2]; MM_STORE(gout1+(n*12+8)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+9)*SIMDD) + - rs[5]; MM_STORE(gout1+(n*12+9)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+10)*SIMDD) + + rs[4] + rs[0]; MM_STORE(gout1+(n*12+10)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+11)*SIMDD) + + rs[3] - rs[1]; MM_STORE(gout1+(n*12+11)*SIMDD, r1);
}
}
CINTsort_gout(gout, gout1, nfc, SIMDD);
}
void int1e_giao_sa10nucsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_giao_sa10nucsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10nucsp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_giao_sa10nucsp_cart
int int1e_giao_sa10nucsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10nucsp;
envs.common_factor *= 0.5;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_giao_sa10nucsp_sph
int int1e_giao_sa10nucsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 1, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_giao_sa10nucsp;
envs.common_factor *= 0.5;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_giao_sa10nucsp_spinor
ALL_CINT1E(int1e_giao_sa10nucsp)
//ALL_CINT1E_FORTRAN_(cint1e_giao_sa10nucsp)
/* <i|NABLA-RINV CROSS SIGMA |SIGMA DOT P j> */
void CINTgout1e_int1e_sa01sp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_nuc(g, envs, count, -1);
int nf = envs->nf;
int nfc = nf * 12;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, n, i;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
__MD r1;
__MD rs[9];
G2E_D_J(g1, g0, envs->i_l+0, envs->j_l+0, 0, 0);
G2E_D_J(g2, g0, envs->i_l+0, envs->j_l+1, 0, 0);
G2E_D_I(g3, g0, envs->i_l+0, envs->j_l+1, 0, 0);
for (ix = 0; ix < envs->g_size * 3 * SIMDD; ix++) {g2[ix] += g3[ix];}
G2E_D_J(g3, g2, envs->i_l+0, envs->j_l+0, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 9; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
}
r1 = + rs[8] + rs[4]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = - rs[3]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = - rs[6]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[7] - rs[5]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = - rs[1]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[0] + rs[8]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = - rs[7]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = - rs[6] + rs[2]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = - rs[2]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = - rs[5]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[4] + rs[0]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[3] - rs[1]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void int1e_sa01sp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {0, 2, 0, 0, 2, 4, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_sa01sp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 2, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sa01sp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_sa01sp_cart
int int1e_sa01sp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 2, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sa01sp;
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_sa01sp_sph
int int1e_sa01sp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 2, 0, 0, 2, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_sa01sp;
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_sa01sp_spinor
ALL_CINT1E(int1e_sa01sp)
//ALL_CINT1E_FORTRAN_(cint1e_sa01sp)
/* <G SIGMA DOT P i|OVLP |SIGMA DOT P j> */
void CINTgout1e_int1e_spgsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_ovlp(g, envs, count);
int nf = envs->nf;
int nfc = nf * 12;
int ix, iy, iz, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3  + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4  + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5  + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6  + envs->g_size * 3 * SIMDD;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
__MD r1;
__MD rs[27];
G1E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0);
G1E_R0I(g2, g0, envs->i_l+1, envs->j_l, 0);
G1E_R0I(g3, g1, envs->i_l+1, envs->j_l, 0);
G1E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0);
G1E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
rs[0] = MM_LOAD(g7+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g6+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g6+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[3] = MM_LOAD(g5+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[4] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[5] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[6] = MM_LOAD(g5+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[7] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[8] = MM_LOAD(g4+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
rs[9] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[10] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g5+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[11] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[12] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g6+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[13] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g7+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[14] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g6+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[15] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[16] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g5+iy*SIMDD) * MM_LOAD(g2+iz*SIMDD);
rs[17] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g4+iy*SIMDD) * MM_LOAD(g3+iz*SIMDD);
rs[18] = MM_LOAD(g3+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[19] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[20] = MM_LOAD(g2+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g5+iz*SIMDD);
rs[21] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[22] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g3+iy*SIMDD) * MM_LOAD(g4+iz*SIMDD);
rs[23] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g2+iy*SIMDD) * MM_LOAD(g5+iz*SIMDD);
rs[24] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g6+iz*SIMDD);
rs[25] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g6+iz*SIMDD);
rs[26] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g7+iz*SIMDD);
r1 = + MM_SET1(c[1])*rs[17] - MM_SET1(c[2])*rs[14] - MM_SET1(c[1])*rs[25] + MM_SET1(c[2])*rs[22]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = + MM_SET1(c[1])*rs[24] - MM_SET1(c[1])*rs[8]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = - MM_SET1(c[2])*rs[4] + MM_SET1(c[2])*rs[12]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + MM_SET1(c[1])*rs[6] - MM_SET1(c[2])*rs[3] + MM_SET1(c[1])*rs[16] - MM_SET1(c[2])*rs[13] + MM_SET1(c[1])*rs[26] - MM_SET1(c[2])*rs[23]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = - MM_SET1(c[0])*rs[17] + MM_SET1(c[0])*rs[25]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + MM_SET1(c[2])*rs[18] - MM_SET1(c[0])*rs[24] - MM_SET1(c[2])*rs[2] + MM_SET1(c[0])*rs[8]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = + MM_SET1(c[2])*rs[1] - MM_SET1(c[2])*rs[9]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = + MM_SET1(c[2])*rs[0] - MM_SET1(c[0])*rs[6] + MM_SET1(c[2])*rs[10] - MM_SET1(c[0])*rs[16] + MM_SET1(c[2])*rs[20] - MM_SET1(c[0])*rs[26]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = + MM_SET1(c[0])*rs[14] - MM_SET1(c[0])*rs[22]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = - MM_SET1(c[1])*rs[18] + MM_SET1(c[1])*rs[2]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + MM_SET1(c[0])*rs[4] - MM_SET1(c[1])*rs[1] - MM_SET1(c[0])*rs[12] + MM_SET1(c[1])*rs[9]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + MM_SET1(c[0])*rs[3] - MM_SET1(c[1])*rs[0] + MM_SET1(c[0])*rs[13] - MM_SET1(c[1])*rs[10] + MM_SET1(c[0])*rs[23] - MM_SET1(c[1])*rs[20]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void int1e_spgsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_spgsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgsp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_spgsp_cart
int int1e_spgsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgsp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_spgsp_sph
int int1e_spgsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgsp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_spgsp_spinor
ALL_CINT1E(int1e_spgsp)
//ALL_CINT1E_FORTRAN_(cint1e_spgsp)
/* <G SIGMA DOT P i|NUC |SIGMA DOT P j> */
void CINTgout1e_int1e_spgnucsp(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int nfc = nf * 12;
double *gout1 = gout + nfc*SIMDD;
int ix, iy, iz, ia, n, i;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0  + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1  + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2  + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3  + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4  + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5  + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6  + envs->g_size * 3 * SIMDD;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
__MD r1;
__MD rs[27];
for (n = 0; n < nfc*SIMDD; n++) { gout1[n] = 0; }
for (ia = 0; ia < envs->natm; ia++) {
CINTg1e_nuc(g, envs, count, ia);
G2E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_R0I(g2, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_R0I(g3, g1, envs->i_l+1, envs->j_l, 0, 0);
G2E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
}
r1 = MM_LOAD(gout1+(n*12+0)*SIMDD) + + MM_SET1(c[1])*rs[17] - MM_SET1(c[2])*rs[14] - MM_SET1(c[1])*rs[25] + MM_SET1(c[2])*rs[22]; MM_STORE(gout1+(n*12+0)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+1)*SIMDD) + + MM_SET1(c[1])*rs[24] - MM_SET1(c[2])*rs[21] - MM_SET1(c[1])*rs[8] + MM_SET1(c[2])*rs[5]; MM_STORE(gout1+(n*12+1)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+2)*SIMDD) + + MM_SET1(c[1])*rs[7] - MM_SET1(c[2])*rs[4] - MM_SET1(c[1])*rs[15] + MM_SET1(c[2])*rs[12]; MM_STORE(gout1+(n*12+2)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+3)*SIMDD) + + MM_SET1(c[1])*rs[6] - MM_SET1(c[2])*rs[3] + MM_SET1(c[1])*rs[16] - MM_SET1(c[2])*rs[13] + MM_SET1(c[1])*rs[26] - MM_SET1(c[2])*rs[23]; MM_STORE(gout1+(n*12+3)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+4)*SIMDD) + + MM_SET1(c[2])*rs[11] - MM_SET1(c[0])*rs[17] - MM_SET1(c[2])*rs[19] + MM_SET1(c[0])*rs[25]; MM_STORE(gout1+(n*12+4)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+5)*SIMDD) + + MM_SET1(c[2])*rs[18] - MM_SET1(c[0])*rs[24] - MM_SET1(c[2])*rs[2] + MM_SET1(c[0])*rs[8]; MM_STORE(gout1+(n*12+5)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+6)*SIMDD) + + MM_SET1(c[2])*rs[1] - MM_SET1(c[0])*rs[7] - MM_SET1(c[2])*rs[9] + MM_SET1(c[0])*rs[15]; MM_STORE(gout1+(n*12+6)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+7)*SIMDD) + + MM_SET1(c[2])*rs[0] - MM_SET1(c[0])*rs[6] + MM_SET1(c[2])*rs[10] - MM_SET1(c[0])*rs[16] + MM_SET1(c[2])*rs[20] - MM_SET1(c[0])*rs[26]; MM_STORE(gout1+(n*12+7)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+8)*SIMDD) + + MM_SET1(c[0])*rs[14] - MM_SET1(c[1])*rs[11] - MM_SET1(c[0])*rs[22] + MM_SET1(c[1])*rs[19]; MM_STORE(gout1+(n*12+8)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+9)*SIMDD) + + MM_SET1(c[0])*rs[21] - MM_SET1(c[1])*rs[18] - MM_SET1(c[0])*rs[5] + MM_SET1(c[1])*rs[2]; MM_STORE(gout1+(n*12+9)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+10)*SIMDD) + + MM_SET1(c[0])*rs[4] - MM_SET1(c[1])*rs[1] - MM_SET1(c[0])*rs[12] + MM_SET1(c[1])*rs[9]; MM_STORE(gout1+(n*12+10)*SIMDD, r1);
r1 = MM_LOAD(gout1+(n*12+11)*SIMDD) + + MM_SET1(c[0])*rs[3] - MM_SET1(c[1])*rs[0] + MM_SET1(c[0])*rs[13] - MM_SET1(c[1])*rs[10] + MM_SET1(c[0])*rs[23] - MM_SET1(c[1])*rs[20]; MM_STORE(gout1+(n*12+11)*SIMDD, r1);
}
}
CINTsort_gout(gout, gout1, nfc, SIMDD);
}
void int1e_spgnucsp_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 3};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_spgnucsp_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgnucsp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_spgnucsp_cart
int int1e_spgnucsp_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgnucsp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_spgnucsp_sph
int int1e_spgnucsp_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 3};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgnucsp;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1ei);
} // int1e_spgnucsp_spinor
ALL_CINT1E(int1e_spgnucsp)
//ALL_CINT1E_FORTRAN_(cint1e_spgnucsp)
/* <G SIGMA DOT P i|NABLA-RINV CROSS SIGMA |j> */
void CINTgout1e_int1e_spgsa01(double *gout, double *g, int *idx, CINTEnvVars *envs, int count) {
CINTg1e_nuc(g, envs, count, -1);
int nf = envs->nf;
int nfc = nf * 36;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, n, i;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
double rirj[3], c[3];
rirj[0] = envs->ri[0] - envs->rj[0];
rirj[1] = envs->ri[1] - envs->rj[1];
rirj[2] = envs->ri[2] - envs->rj[2];
c[0] = 1 * rirj[0];
c[1] = 1 * rirj[1];
c[2] = 1 * rirj[2];
__MD r1;
__MD rs[27];
G2E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, 0, 0);
G2E_D_I(g2, g0, envs->i_l+2, envs->j_l+0, 0, 0);
for (ix = 0; ix < envs->g_size * 3 * SIMDD; ix++) {g1[ix] += g2[ix];}
G2E_R0I(g2, g0, envs->i_l+1, envs->j_l, 0, 0);
G2E_R0I(g3, g1, envs->i_l+1, envs->j_l, 0, 0);
G2E_D_I(g4, g0, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g5, g1, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g6, g2, envs->i_l+0, envs->j_l, 0, 0);
G2E_D_I(g7, g3, envs->i_l+0, envs->j_l, 0, 0);
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
}
r1 = - MM_SET1(c[1])*rs[16] + MM_SET1(c[2])*rs[13] - MM_SET1(c[1])*rs[26] + MM_SET1(c[2])*rs[23]; GOUT_SCATTER(gout, n*36+0, r1);
r1 = + MM_SET1(c[1])*rs[7] - MM_SET1(c[2])*rs[4]; GOUT_SCATTER(gout, n*36+1, r1);
r1 = + MM_SET1(c[1])*rs[8] - MM_SET1(c[2])*rs[5]; GOUT_SCATTER(gout, n*36+2, r1);
r1 = + MM_SET1(c[1])*rs[17] - MM_SET1(c[2])*rs[14] - MM_SET1(c[1])*rs[25] + MM_SET1(c[2])*rs[22]; GOUT_SCATTER(gout, n*36+3, r1);
r1 = + MM_SET1(c[1])*rs[15] - MM_SET1(c[2])*rs[12]; GOUT_SCATTER(gout, n*36+4, r1);
r1 = - MM_SET1(c[1])*rs[26] + MM_SET1(c[2])*rs[23] - MM_SET1(c[1])*rs[6] + MM_SET1(c[2])*rs[3]; GOUT_SCATTER(gout, n*36+5, r1);
r1 = + MM_SET1(c[1])*rs[17] - MM_SET1(c[2])*rs[14]; GOUT_SCATTER(gout, n*36+6, r1);
r1 = - MM_SET1(c[1])*rs[8] + MM_SET1(c[2])*rs[5] + MM_SET1(c[1])*rs[24] - MM_SET1(c[2])*rs[21]; GOUT_SCATTER(gout, n*36+7, r1);
r1 = + MM_SET1(c[1])*rs[24] - MM_SET1(c[2])*rs[21]; GOUT_SCATTER(gout, n*36+8, r1);
r1 = + MM_SET1(c[1])*rs[25] - MM_SET1(c[2])*rs[22]; GOUT_SCATTER(gout, n*36+9, r1);
r1 = - MM_SET1(c[1])*rs[6] + MM_SET1(c[2])*rs[3] - MM_SET1(c[1])*rs[16] + MM_SET1(c[2])*rs[13]; GOUT_SCATTER(gout, n*36+10, r1);
r1 = + MM_SET1(c[1])*rs[7] - MM_SET1(c[2])*rs[4] - MM_SET1(c[1])*rs[15] + MM_SET1(c[2])*rs[12]; GOUT_SCATTER(gout, n*36+11, r1);
r1 = - MM_SET1(c[2])*rs[10] + MM_SET1(c[0])*rs[16] - MM_SET1(c[2])*rs[20] + MM_SET1(c[0])*rs[26]; GOUT_SCATTER(gout, n*36+12, r1);
r1 = + MM_SET1(c[2])*rs[1] - MM_SET1(c[0])*rs[7]; GOUT_SCATTER(gout, n*36+13, r1);
r1 = + MM_SET1(c[2])*rs[2] - MM_SET1(c[0])*rs[8]; GOUT_SCATTER(gout, n*36+14, r1);
r1 = + MM_SET1(c[2])*rs[11] - MM_SET1(c[0])*rs[17] - MM_SET1(c[2])*rs[19] + MM_SET1(c[0])*rs[25]; GOUT_SCATTER(gout, n*36+15, r1);
r1 = + MM_SET1(c[2])*rs[9] - MM_SET1(c[0])*rs[15]; GOUT_SCATTER(gout, n*36+16, r1);
r1 = - MM_SET1(c[2])*rs[20] + MM_SET1(c[0])*rs[26] - MM_SET1(c[2])*rs[0] + MM_SET1(c[0])*rs[6]; GOUT_SCATTER(gout, n*36+17, r1);
r1 = + MM_SET1(c[2])*rs[11] - MM_SET1(c[0])*rs[17]; GOUT_SCATTER(gout, n*36+18, r1);
r1 = - MM_SET1(c[2])*rs[2] + MM_SET1(c[0])*rs[8] + MM_SET1(c[2])*rs[18] - MM_SET1(c[0])*rs[24]; GOUT_SCATTER(gout, n*36+19, r1);
r1 = + MM_SET1(c[2])*rs[18] - MM_SET1(c[0])*rs[24]; GOUT_SCATTER(gout, n*36+20, r1);
r1 = + MM_SET1(c[2])*rs[19] - MM_SET1(c[0])*rs[25]; GOUT_SCATTER(gout, n*36+21, r1);
r1 = - MM_SET1(c[2])*rs[0] + MM_SET1(c[0])*rs[6] - MM_SET1(c[2])*rs[10] + MM_SET1(c[0])*rs[16]; GOUT_SCATTER(gout, n*36+22, r1);
r1 = + MM_SET1(c[2])*rs[1] - MM_SET1(c[0])*rs[7] - MM_SET1(c[2])*rs[9] + MM_SET1(c[0])*rs[15]; GOUT_SCATTER(gout, n*36+23, r1);
r1 = - MM_SET1(c[0])*rs[13] + MM_SET1(c[1])*rs[10] - MM_SET1(c[0])*rs[23] + MM_SET1(c[1])*rs[20]; GOUT_SCATTER(gout, n*36+24, r1);
r1 = + MM_SET1(c[0])*rs[4] - MM_SET1(c[1])*rs[1]; GOUT_SCATTER(gout, n*36+25, r1);
r1 = + MM_SET1(c[0])*rs[5] - MM_SET1(c[1])*rs[2]; GOUT_SCATTER(gout, n*36+26, r1);
r1 = + MM_SET1(c[0])*rs[14] - MM_SET1(c[1])*rs[11] - MM_SET1(c[0])*rs[22] + MM_SET1(c[1])*rs[19]; GOUT_SCATTER(gout, n*36+27, r1);
r1 = + MM_SET1(c[0])*rs[12] - MM_SET1(c[1])*rs[9]; GOUT_SCATTER(gout, n*36+28, r1);
r1 = - MM_SET1(c[0])*rs[23] + MM_SET1(c[1])*rs[20] - MM_SET1(c[0])*rs[3] + MM_SET1(c[1])*rs[0]; GOUT_SCATTER(gout, n*36+29, r1);
r1 = + MM_SET1(c[0])*rs[14] - MM_SET1(c[1])*rs[11]; GOUT_SCATTER(gout, n*36+30, r1);
r1 = - MM_SET1(c[0])*rs[5] + MM_SET1(c[1])*rs[2] + MM_SET1(c[0])*rs[21] - MM_SET1(c[1])*rs[18]; GOUT_SCATTER(gout, n*36+31, r1);
r1 = + MM_SET1(c[0])*rs[21] - MM_SET1(c[1])*rs[18]; GOUT_SCATTER(gout, n*36+32, r1);
r1 = + MM_SET1(c[0])*rs[22] - MM_SET1(c[1])*rs[19]; GOUT_SCATTER(gout, n*36+33, r1);
r1 = - MM_SET1(c[0])*rs[3] + MM_SET1(c[1])*rs[0] - MM_SET1(c[0])*rs[13] + MM_SET1(c[1])*rs[10]; GOUT_SCATTER(gout, n*36+34, r1);
r1 = + MM_SET1(c[0])*rs[4] - MM_SET1(c[1])*rs[1] - MM_SET1(c[0])*rs[12] + MM_SET1(c[1])*rs[9]; GOUT_SCATTER(gout, n*36+35, r1);
}}
void int1e_spgsa01_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 9};
CINTall_1e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int1e_spgsa01_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgsa01;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = envs.nfi * envs.x_ctr[0];
counts[1] = envs.nfj * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_cart_1e);
} // int1e_spgsa01_cart
int int1e_spgsa01_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgsa01;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = (envs.i_l*2+1) * envs.x_ctr[0];
counts[1] = (envs.j_l*2+1) * envs.x_ctr[1];
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_e1 * envs.ncomp_tensor; i++) {
c2s_dset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_drv(out, dims, &envs, opt, cache, &c2s_sph_1e);
} // int1e_spgsa01_sph
int int1e_spgsa01_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 0, 9};
CINTEnvVars envs;
CINTinit_int1e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout1e_int1e_spgsa01;
envs.common_factor *= 0.5;
if (out != NULL && envs.shls[0] == envs.shls[1]) {
int i, nout;
int counts[4];
counts[0] = CINTcgto_spinor(envs.shls[0], envs.bas);
counts[1] = CINTcgto_spinor(envs.shls[1], envs.bas);
counts[2] = 1;
counts[3] = 1;
if (dims == NULL) { dims = counts; }
nout = dims[0] * dims[1];
for (i = 0; i < envs.ncomp_tensor; i++) {
c2s_zset0(out+nout*i, dims, counts); }
return 0; }
return CINT1e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_1e);
} // int1e_spgsa01_spinor
ALL_CINT1E(int1e_spgsa01)
//ALL_CINT1E_FORTRAN_(cint1e_spgsa01)
