/*
 * Qcint is a general GTO integral library for computational chemistry
 * Copyright (C) 2014- Qiming Sun <osirpt.sun@gmail.com>
 *
 * This file is part of Qcint.
 *
 * Qcint is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Description: code generated by  gen-code.cl
 */
#include <stdlib.h>
#include "cint_bas.h"
#include "simd.h"
#include "cart2sph.h"
#include "g1e.h"
#include "g2e.h"
#include "optimizer.h"
#include "cint1e.h"
#include "cint2e.h"
#include "misc.h"
#include "c2f.h"
/* <k NABLA i|R12 |j l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA i j|R12 |k l) */
void CINTgout2e_int2e_ip1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 3;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
G2E_D_I(g1, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[3];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
switch (nrys_roots) {
case 1:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
break;
case 2:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g1+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g1+(iz+1)*SIMDD);
break;
case 3:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g1+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g1+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g1+(iz+1)*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g1+(iz+2)*SIMDD);
break;
case 4:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+3)*SIMDD) * MM_LOAD(g0+(iy+3)*SIMDD) * MM_LOAD(g0+(iz+3)*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g1+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g1+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+3)*SIMDD) * MM_LOAD(g1+(iy+3)*SIMDD) * MM_LOAD(g0+(iz+3)*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g1+(iz+1)*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g1+(iz+2)*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+3)*SIMDD) * MM_LOAD(g0+(iy+3)*SIMDD) * MM_LOAD(g1+(iz+3)*SIMDD);
break;
default:
for (i = 0; i < 3; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
} break;}
r1 = + rs[0]; GOUT_SCATTER(gout, n*3+0, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*3+1, r1);
r1 = + rs[2]; GOUT_SCATTER(gout, n*3+2, r1);
}}
void CINTgout2e_int2e_ip1_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
G2E_D_I_SIMD1(g1, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[3];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
switch (nrys_roots) {
case 1:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
break;
case 2:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1];
break;
case 3:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2];
break;
case 4:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3];
break;
default:
for (i = 0; i < 3; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g1[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g0[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g0[ix+i] * g0[iy+i] * g1[iz+i];
} break;}
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
}}
void int2e_ip1_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ip1_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ip1_cart
int int2e_ip1_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ip1_sph
int int2e_ip1_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 0, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_2e1, &c2s_sf_2e2);
} // int2e_ip1_spinor
ALL_CINT(int2e_ip1)
//ALL_CINT_FORTRAN_(cint2e_ip1)
/* <NABLA k i|R12 |j l> : i,j \in electron 1; k,l \in electron 2
 * = (i j|R12 |NABLA k l) */
void CINTgout2e_int2e_ip2(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 3;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
G2E_D_K(g1, g0, envs->i_l+0, envs->j_l+0, envs->k_l+0, envs->l_l);
__MD r1;
__MD rs[3];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
switch (nrys_roots) {
case 1:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
break;
case 2:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g1+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g1+(iz+1)*SIMDD);
break;
case 3:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g1+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g1+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g1+(iz+1)*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g1+(iz+2)*SIMDD);
break;
case 4:
rs[0] = MM_LOAD(g1+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[0]+= MM_LOAD(g1+(ix+3)*SIMDD) * MM_LOAD(g0+(iy+3)*SIMDD) * MM_LOAD(g0+(iz+3)*SIMDD);
rs[1] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g1+iy*SIMDD) * MM_LOAD(g0+iz*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g1+(iy+1)*SIMDD) * MM_LOAD(g0+(iz+1)*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g1+(iy+2)*SIMDD) * MM_LOAD(g0+(iz+2)*SIMDD);
rs[1]+= MM_LOAD(g0+(ix+3)*SIMDD) * MM_LOAD(g1+(iy+3)*SIMDD) * MM_LOAD(g0+(iz+3)*SIMDD);
rs[2] = MM_LOAD(g0+ix*SIMDD) * MM_LOAD(g0+iy*SIMDD) * MM_LOAD(g1+iz*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+1)*SIMDD) * MM_LOAD(g0+(iy+1)*SIMDD) * MM_LOAD(g1+(iz+1)*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+2)*SIMDD) * MM_LOAD(g0+(iy+2)*SIMDD) * MM_LOAD(g1+(iz+2)*SIMDD);
rs[2]+= MM_LOAD(g0+(ix+3)*SIMDD) * MM_LOAD(g0+(iy+3)*SIMDD) * MM_LOAD(g1+(iz+3)*SIMDD);
break;
default:
for (i = 0; i < 3; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
} break;}
r1 = + rs[0]; GOUT_SCATTER(gout, n*3+0, r1);
r1 = + rs[1]; GOUT_SCATTER(gout, n*3+1, r1);
r1 = + rs[2]; GOUT_SCATTER(gout, n*3+2, r1);
}}
void CINTgout2e_int2e_ip2_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
G2E_D_K_SIMD1(g1, g0, envs->i_l+0, envs->j_l+0, envs->k_l+0, envs->l_l);
double s[3];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
switch (nrys_roots) {
case 1:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0];
break;
case 2:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1];
break;
case 3:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2];
break;
case 4:
s[0] = + g1[ix+0]*g0[iy+0]*g0[iz+0]+ g1[ix+1]*g0[iy+1]*g0[iz+1]+ g1[ix+2]*g0[iy+2]*g0[iz+2]+ g1[ix+3]*g0[iy+3]*g0[iz+3];
s[1] = + g0[ix+0]*g1[iy+0]*g0[iz+0]+ g0[ix+1]*g1[iy+1]*g0[iz+1]+ g0[ix+2]*g1[iy+2]*g0[iz+2]+ g0[ix+3]*g1[iy+3]*g0[iz+3];
s[2] = + g0[ix+0]*g0[iy+0]*g1[iz+0]+ g0[ix+1]*g0[iy+1]*g1[iz+1]+ g0[ix+2]*g0[iy+2]*g1[iz+2]+ g0[ix+3]*g0[iy+3]*g1[iz+3];
break;
default:
for (i = 0; i < 3; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g1[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g0[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g0[ix+i] * g0[iy+i] * g1[iz+i];
} break;}
gout[n*3+0] = + s[0];
gout[n*3+1] = + s[1];
gout[n*3+2] = + s[2];
}}
void int2e_ip2_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {0, 0, 1, 0, 1, 1, 1, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ip2_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 0, 1, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip2_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ip2_cart
int int2e_ip2_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 0, 1, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip2_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ip2_sph
int int2e_ip2_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {0, 0, 1, 0, 1, 1, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip2_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_2e1, &c2s_sf_2e2);
} // int2e_ip2_spinor
ALL_CINT(int2e_ip2)
//ALL_CINT_FORTRAN_(cint2e_ip2)
/* <k NABLA SIGMA DOT P i|R12 |SIGMA DOT P j l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT P i SIGMA DOT P j|R12 |k l) */
void CINTgout2e_int2e_ipspsp1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 12;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_D_J(g1, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I(g2, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g3, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
}
r1 = + rs[11] - rs[19]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = + rs[18] - rs[2]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = + rs[1] - rs[9]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[0] + rs[10] + rs[20]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = + rs[14] - rs[22]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[21] - rs[5]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = + rs[4] - rs[12]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = + rs[3] + rs[13] + rs[23]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = + rs[17] - rs[25]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = + rs[24] - rs[8]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[7] - rs[15]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[6] + rs[16] + rs[26]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void CINTgout2e_int2e_ipspsp1_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_D_J_SIMD1(g1, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g2, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g3, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
gout[n*12+0] = + s[11] - s[19];
gout[n*12+1] = + s[18] - s[2];
gout[n*12+2] = + s[1] - s[9];
gout[n*12+3] = + s[0] + s[10] + s[20];
gout[n*12+4] = + s[14] - s[22];
gout[n*12+5] = + s[21] - s[5];
gout[n*12+6] = + s[4] - s[12];
gout[n*12+7] = + s[3] + s[13] + s[23];
gout[n*12+8] = + s[17] - s[25];
gout[n*12+9] = + s[24] - s[8];
gout[n*12+10] = + s[7] - s[15];
gout[n*12+11] = + s[6] + s[16] + s[26];
}}
void int2e_ipspsp1_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ipspsp1_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipspsp1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipspsp1_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ipspsp1_cart
int int2e_ipspsp1_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipspsp1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipspsp1_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ipspsp1_sph
int int2e_ipspsp1_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipspsp1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipspsp1_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_2e1, &c2s_sf_2e2);
} // int2e_ipspsp1_spinor
ALL_CINT(int2e_ipspsp1)
//ALL_CINT_FORTRAN_(cint2e_ipspsp1)
/* <SIGMA DOT P k NABLA i|R12 |j SIGMA DOT P l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA i j|R12 |SIGMA DOT P k SIGMA DOT P l) */
void CINTgout2e_int2e_ip1spsp2(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 12;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_D_L(g1, g0, envs->i_l+1, envs->j_l+0, envs->k_l+1, envs->l_l+0);
G2E_D_K(g2, g0, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_D_K(g3, g1, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_D_I(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
}
r1 = + rs[5] - rs[7]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = + rs[6] - rs[2]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = + rs[1] - rs[3]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[0] + rs[4] + rs[8]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = + rs[14] - rs[16]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[15] - rs[11]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = + rs[10] - rs[12]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = + rs[9] + rs[13] + rs[17]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = + rs[23] - rs[25]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = + rs[24] - rs[20]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[19] - rs[21]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[18] + rs[22] + rs[26]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void CINTgout2e_int2e_ip1spsp2_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_D_L_SIMD1(g1, g0, envs->i_l+1, envs->j_l+0, envs->k_l+1, envs->l_l+0);
G2E_D_K_SIMD1(g2, g0, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_D_K_SIMD1(g3, g1, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_D_I_SIMD1(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
gout[n*12+0] = + s[5] - s[7];
gout[n*12+1] = + s[6] - s[2];
gout[n*12+2] = + s[1] - s[3];
gout[n*12+3] = + s[0] + s[4] + s[8];
gout[n*12+4] = + s[14] - s[16];
gout[n*12+5] = + s[15] - s[11];
gout[n*12+6] = + s[10] - s[12];
gout[n*12+7] = + s[9] + s[13] + s[17];
gout[n*12+8] = + s[23] - s[25];
gout[n*12+9] = + s[24] - s[20];
gout[n*12+10] = + s[19] - s[21];
gout[n*12+11] = + s[18] + s[22] + s[26];
}}
void int2e_ip1spsp2_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ip1spsp2_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1spsp2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1spsp2_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ip1spsp2_cart
int int2e_ip1spsp2_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1spsp2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1spsp2_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ip1spsp2_sph
int int2e_ip1spsp2_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1spsp2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1spsp2_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_2e1, &c2s_si_2e2);
} // int2e_ip1spsp2_spinor
ALL_CINT(int2e_ip1spsp2)
//ALL_CINT_FORTRAN_(cint2e_ip1spsp2)
/* <SIGMA DOT P k NABLA SIGMA DOT P i|R12 |SIGMA DOT P j SIGMA DOT P l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT P i SIGMA DOT P j|R12 |SIGMA DOT P k SIGMA DOT P l) */
void CINTgout2e_int2e_ipspsp1spsp2(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 48;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
double *RESTRICT g8 = g7 + envs->g_size * 3 * SIMDD;
double *RESTRICT g9 = g8 + envs->g_size * 3 * SIMDD;
double *RESTRICT g10 = g9 + envs->g_size * 3 * SIMDD;
double *RESTRICT g11 = g10 + envs->g_size * 3 * SIMDD;
double *RESTRICT g12 = g11 + envs->g_size * 3 * SIMDD;
double *RESTRICT g13 = g12 + envs->g_size * 3 * SIMDD;
double *RESTRICT g14 = g13 + envs->g_size * 3 * SIMDD;
double *RESTRICT g15 = g14 + envs->g_size * 3 * SIMDD;
double *RESTRICT g16 = g15 + envs->g_size * 3 * SIMDD;
double *RESTRICT g17 = g16 + envs->g_size * 3 * SIMDD;
double *RESTRICT g18 = g17 + envs->g_size * 3 * SIMDD;
double *RESTRICT g19 = g18 + envs->g_size * 3 * SIMDD;
double *RESTRICT g20 = g19 + envs->g_size * 3 * SIMDD;
double *RESTRICT g21 = g20 + envs->g_size * 3 * SIMDD;
double *RESTRICT g22 = g21 + envs->g_size * 3 * SIMDD;
double *RESTRICT g23 = g22 + envs->g_size * 3 * SIMDD;
double *RESTRICT g24 = g23 + envs->g_size * 3 * SIMDD;
double *RESTRICT g25 = g24 + envs->g_size * 3 * SIMDD;
double *RESTRICT g26 = g25 + envs->g_size * 3 * SIMDD;
double *RESTRICT g27 = g26 + envs->g_size * 3 * SIMDD;
double *RESTRICT g28 = g27 + envs->g_size * 3 * SIMDD;
double *RESTRICT g29 = g28 + envs->g_size * 3 * SIMDD;
double *RESTRICT g30 = g29 + envs->g_size * 3 * SIMDD;
double *RESTRICT g31 = g30 + envs->g_size * 3 * SIMDD;
G2E_D_L(g1, g0, envs->i_l+2, envs->j_l+1, envs->k_l+1, envs->l_l+0);
G2E_D_K(g2, g0, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_D_K(g3, g1, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_D_J(g4, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_J(g5, g1, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_J(g6, g2, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_J(g7, g3, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I(g8, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g9, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g10, g2, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g11, g3, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g12, g4, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g13, g5, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g14, g6, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g15, g7, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g16, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g17, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g18, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g19, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g20, g4, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g21, g5, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g22, g6, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g23, g7, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g24, g8, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g25, g9, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g26, g10, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g27, g11, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g28, g12, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g29, g13, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g30, g14, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g31, g15, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[243];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 243; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g31+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g30+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g30+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g29+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g29+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g27+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g27+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[27] += MM_LOAD(g23+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[28] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[29] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[30] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[31] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[32] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[33] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[34] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[35] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[36] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[37] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[38] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[39] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[40] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g15+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[41] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[42] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[43] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[44] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[45] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[46] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[47] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[48] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[49] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[50] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[51] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[52] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[53] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[54] += MM_LOAD(g23+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[55] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[56] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[57] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[58] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[59] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[60] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[61] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[62] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[63] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[64] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[65] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[66] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[67] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[68] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[69] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[70] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[71] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[72] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[73] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[74] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[75] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[76] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[77] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[78] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[79] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[80] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g15+(iz+i)*SIMDD);
rs[81] += MM_LOAD(g15+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[82] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[83] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[84] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[85] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[86] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[87] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[88] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[89] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[90] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[91] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[92] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[93] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[94] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g23+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[95] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[96] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[97] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[98] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[99] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[100] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[101] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[102] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[103] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[104] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[105] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[106] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[107] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[108] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[109] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[110] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[111] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[112] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g27+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[113] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[114] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[115] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[116] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[117] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[118] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g29+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[119] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[120] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g30+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[121] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g31+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[122] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g30+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[123] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[124] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g29+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[125] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[126] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[127] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[128] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[129] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[130] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g27+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[131] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[132] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[133] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[134] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[135] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[136] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[137] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[138] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[139] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[140] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[141] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[142] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[143] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[144] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[145] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[146] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[147] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[148] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g23+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[149] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[150] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[151] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[152] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[153] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[154] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[155] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[156] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[157] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[158] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[159] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[160] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[161] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g15+(iz+i)*SIMDD);
rs[162] += MM_LOAD(g15+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[163] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[164] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[165] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[166] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[167] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[168] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[169] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[170] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[171] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[172] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[173] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[174] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[175] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[176] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[177] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[178] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[179] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[180] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[181] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[182] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[183] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[184] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[185] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[186] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[187] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[188] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g23+(iz+i)*SIMDD);
rs[189] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[190] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[191] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[192] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[193] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[194] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[195] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[196] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[197] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[198] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[199] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[200] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[201] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[202] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g15+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[203] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[204] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[205] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[206] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[207] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[208] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[209] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[210] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[211] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[212] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[213] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[214] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[215] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g23+(iz+i)*SIMDD);
rs[216] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[217] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[218] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[219] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[220] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[221] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[222] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[223] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[224] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g27+(iz+i)*SIMDD);
rs[225] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[226] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[227] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[228] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[229] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[230] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[231] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[232] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[233] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g27+(iz+i)*SIMDD);
rs[234] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[235] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[236] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g29+(iz+i)*SIMDD);
rs[237] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[238] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[239] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g29+(iz+i)*SIMDD);
rs[240] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g30+(iz+i)*SIMDD);
rs[241] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g30+(iz+i)*SIMDD);
rs[242] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g31+(iz+i)*SIMDD);
}
r1 = + rs[104] - rs[176] - rs[106] + rs[178]; GOUT_SCATTER(gout, n*48+0, r1);
r1 = + rs[167] - rs[23] - rs[169] + rs[25]; GOUT_SCATTER(gout, n*48+1, r1);
r1 = + rs[14] - rs[86] - rs[16] + rs[88]; GOUT_SCATTER(gout, n*48+2, r1);
r1 = + rs[5] + rs[95] + rs[185] - rs[7] - rs[97] - rs[187]; GOUT_SCATTER(gout, n*48+3, r1);
r1 = + rs[105] - rs[177] - rs[101] + rs[173]; GOUT_SCATTER(gout, n*48+4, r1);
r1 = + rs[168] - rs[24] - rs[164] + rs[20]; GOUT_SCATTER(gout, n*48+5, r1);
r1 = + rs[15] - rs[87] - rs[11] + rs[83]; GOUT_SCATTER(gout, n*48+6, r1);
r1 = + rs[6] + rs[96] + rs[186] - rs[2] - rs[92] - rs[182]; GOUT_SCATTER(gout, n*48+7, r1);
r1 = + rs[100] - rs[172] - rs[102] + rs[174]; GOUT_SCATTER(gout, n*48+8, r1);
r1 = + rs[163] - rs[19] - rs[165] + rs[21]; GOUT_SCATTER(gout, n*48+9, r1);
r1 = + rs[10] - rs[82] - rs[12] + rs[84]; GOUT_SCATTER(gout, n*48+10, r1);
r1 = + rs[1] + rs[91] + rs[181] - rs[3] - rs[93] - rs[183]; GOUT_SCATTER(gout, n*48+11, r1);
r1 = + rs[99] - rs[171] + rs[103] - rs[175] + rs[107] - rs[179]; GOUT_SCATTER(gout, n*48+12, r1);
r1 = + rs[162] - rs[18] + rs[166] - rs[22] + rs[170] - rs[26]; GOUT_SCATTER(gout, n*48+13, r1);
r1 = + rs[9] - rs[81] + rs[13] - rs[85] + rs[17] - rs[89]; GOUT_SCATTER(gout, n*48+14, r1);
r1 = + rs[0] + rs[90] + rs[180] + rs[4] + rs[94] + rs[184] + rs[8] + rs[98] + rs[188]; GOUT_SCATTER(gout, n*48+15, r1);
r1 = + rs[131] - rs[203] - rs[133] + rs[205]; GOUT_SCATTER(gout, n*48+16, r1);
r1 = + rs[194] - rs[50] - rs[196] + rs[52]; GOUT_SCATTER(gout, n*48+17, r1);
r1 = + rs[41] - rs[113] - rs[43] + rs[115]; GOUT_SCATTER(gout, n*48+18, r1);
r1 = + rs[32] + rs[122] + rs[212] - rs[34] - rs[124] - rs[214]; GOUT_SCATTER(gout, n*48+19, r1);
r1 = + rs[132] - rs[204] - rs[128] + rs[200]; GOUT_SCATTER(gout, n*48+20, r1);
r1 = + rs[195] - rs[51] - rs[191] + rs[47]; GOUT_SCATTER(gout, n*48+21, r1);
r1 = + rs[42] - rs[114] - rs[38] + rs[110]; GOUT_SCATTER(gout, n*48+22, r1);
r1 = + rs[33] + rs[123] + rs[213] - rs[29] - rs[119] - rs[209]; GOUT_SCATTER(gout, n*48+23, r1);
r1 = + rs[127] - rs[199] - rs[129] + rs[201]; GOUT_SCATTER(gout, n*48+24, r1);
r1 = + rs[190] - rs[46] - rs[192] + rs[48]; GOUT_SCATTER(gout, n*48+25, r1);
r1 = + rs[37] - rs[109] - rs[39] + rs[111]; GOUT_SCATTER(gout, n*48+26, r1);
r1 = + rs[28] + rs[118] + rs[208] - rs[30] - rs[120] - rs[210]; GOUT_SCATTER(gout, n*48+27, r1);
r1 = + rs[126] - rs[198] + rs[130] - rs[202] + rs[134] - rs[206]; GOUT_SCATTER(gout, n*48+28, r1);
r1 = + rs[189] - rs[45] + rs[193] - rs[49] + rs[197] - rs[53]; GOUT_SCATTER(gout, n*48+29, r1);
r1 = + rs[36] - rs[108] + rs[40] - rs[112] + rs[44] - rs[116]; GOUT_SCATTER(gout, n*48+30, r1);
r1 = + rs[27] + rs[117] + rs[207] + rs[31] + rs[121] + rs[211] + rs[35] + rs[125] + rs[215]; GOUT_SCATTER(gout, n*48+31, r1);
r1 = + rs[158] - rs[230] - rs[160] + rs[232]; GOUT_SCATTER(gout, n*48+32, r1);
r1 = + rs[221] - rs[77] - rs[223] + rs[79]; GOUT_SCATTER(gout, n*48+33, r1);
r1 = + rs[68] - rs[140] - rs[70] + rs[142]; GOUT_SCATTER(gout, n*48+34, r1);
r1 = + rs[59] + rs[149] + rs[239] - rs[61] - rs[151] - rs[241]; GOUT_SCATTER(gout, n*48+35, r1);
r1 = + rs[159] - rs[231] - rs[155] + rs[227]; GOUT_SCATTER(gout, n*48+36, r1);
r1 = + rs[222] - rs[78] - rs[218] + rs[74]; GOUT_SCATTER(gout, n*48+37, r1);
r1 = + rs[69] - rs[141] - rs[65] + rs[137]; GOUT_SCATTER(gout, n*48+38, r1);
r1 = + rs[60] + rs[150] + rs[240] - rs[56] - rs[146] - rs[236]; GOUT_SCATTER(gout, n*48+39, r1);
r1 = + rs[154] - rs[226] - rs[156] + rs[228]; GOUT_SCATTER(gout, n*48+40, r1);
r1 = + rs[217] - rs[73] - rs[219] + rs[75]; GOUT_SCATTER(gout, n*48+41, r1);
r1 = + rs[64] - rs[136] - rs[66] + rs[138]; GOUT_SCATTER(gout, n*48+42, r1);
r1 = + rs[55] + rs[145] + rs[235] - rs[57] - rs[147] - rs[237]; GOUT_SCATTER(gout, n*48+43, r1);
r1 = + rs[153] - rs[225] + rs[157] - rs[229] + rs[161] - rs[233]; GOUT_SCATTER(gout, n*48+44, r1);
r1 = + rs[216] - rs[72] + rs[220] - rs[76] + rs[224] - rs[80]; GOUT_SCATTER(gout, n*48+45, r1);
r1 = + rs[63] - rs[135] + rs[67] - rs[139] + rs[71] - rs[143]; GOUT_SCATTER(gout, n*48+46, r1);
r1 = + rs[54] + rs[144] + rs[234] + rs[58] + rs[148] + rs[238] + rs[62] + rs[152] + rs[242]; GOUT_SCATTER(gout, n*48+47, r1);
}}
void CINTgout2e_int2e_ipspsp1spsp2_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
double *RESTRICT g8 = g7 + envs->g_size * 3 * SIMDD;
double *RESTRICT g9 = g8 + envs->g_size * 3 * SIMDD;
double *RESTRICT g10 = g9 + envs->g_size * 3 * SIMDD;
double *RESTRICT g11 = g10 + envs->g_size * 3 * SIMDD;
double *RESTRICT g12 = g11 + envs->g_size * 3 * SIMDD;
double *RESTRICT g13 = g12 + envs->g_size * 3 * SIMDD;
double *RESTRICT g14 = g13 + envs->g_size * 3 * SIMDD;
double *RESTRICT g15 = g14 + envs->g_size * 3 * SIMDD;
double *RESTRICT g16 = g15 + envs->g_size * 3 * SIMDD;
double *RESTRICT g17 = g16 + envs->g_size * 3 * SIMDD;
double *RESTRICT g18 = g17 + envs->g_size * 3 * SIMDD;
double *RESTRICT g19 = g18 + envs->g_size * 3 * SIMDD;
double *RESTRICT g20 = g19 + envs->g_size * 3 * SIMDD;
double *RESTRICT g21 = g20 + envs->g_size * 3 * SIMDD;
double *RESTRICT g22 = g21 + envs->g_size * 3 * SIMDD;
double *RESTRICT g23 = g22 + envs->g_size * 3 * SIMDD;
double *RESTRICT g24 = g23 + envs->g_size * 3 * SIMDD;
double *RESTRICT g25 = g24 + envs->g_size * 3 * SIMDD;
double *RESTRICT g26 = g25 + envs->g_size * 3 * SIMDD;
double *RESTRICT g27 = g26 + envs->g_size * 3 * SIMDD;
double *RESTRICT g28 = g27 + envs->g_size * 3 * SIMDD;
double *RESTRICT g29 = g28 + envs->g_size * 3 * SIMDD;
double *RESTRICT g30 = g29 + envs->g_size * 3 * SIMDD;
double *RESTRICT g31 = g30 + envs->g_size * 3 * SIMDD;
G2E_D_L_SIMD1(g1, g0, envs->i_l+2, envs->j_l+1, envs->k_l+1, envs->l_l+0);
G2E_D_K_SIMD1(g2, g0, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_D_K_SIMD1(g3, g1, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_D_J_SIMD1(g4, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_J_SIMD1(g5, g1, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_J_SIMD1(g6, g2, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_J_SIMD1(g7, g3, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g8, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g9, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g10, g2, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g11, g3, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g12, g4, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g13, g5, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g14, g6, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g15, g7, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g16, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g17, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g18, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g19, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g20, g4, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g21, g5, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g22, g6, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g23, g7, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g24, g8, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g25, g9, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g26, g10, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g27, g11, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g28, g12, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g29, g13, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g30, g14, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g31, g15, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[243];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 243; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g31[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g30[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g30[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g29[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g28[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g28[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g29[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g28[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g28[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g27[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g26[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g26[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g25[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g24[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g24[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g25[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g24[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g24[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g27[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g26[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g26[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g25[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g24[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g24[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g25[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g24[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g24[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g23[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g22[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g22[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g21[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g20[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g20[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g21[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g20[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g20[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g19[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g18[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g18[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g17[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g16[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g16[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g17[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g16[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g16[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g19[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g18[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g18[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g17[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g16[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g16[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g17[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g16[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g16[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g23[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g22[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g22[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g21[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g20[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g20[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g21[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g20[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g20[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g19[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g18[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g18[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g17[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g16[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g16[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g17[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g16[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g16[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g19[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g18[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g18[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g17[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g16[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g16[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g17[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g16[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g16[ix+i] * g0[iy+i] * g15[iz+i];
s[81] += g15[ix+i] * g16[iy+i] * g0[iz+i];
s[82] += g14[ix+i] * g17[iy+i] * g0[iz+i];
s[83] += g14[ix+i] * g16[iy+i] * g1[iz+i];
s[84] += g13[ix+i] * g18[iy+i] * g0[iz+i];
s[85] += g12[ix+i] * g19[iy+i] * g0[iz+i];
s[86] += g12[ix+i] * g18[iy+i] * g1[iz+i];
s[87] += g13[ix+i] * g16[iy+i] * g2[iz+i];
s[88] += g12[ix+i] * g17[iy+i] * g2[iz+i];
s[89] += g12[ix+i] * g16[iy+i] * g3[iz+i];
s[90] += g11[ix+i] * g20[iy+i] * g0[iz+i];
s[91] += g10[ix+i] * g21[iy+i] * g0[iz+i];
s[92] += g10[ix+i] * g20[iy+i] * g1[iz+i];
s[93] += g9[ix+i] * g22[iy+i] * g0[iz+i];
s[94] += g8[ix+i] * g23[iy+i] * g0[iz+i];
s[95] += g8[ix+i] * g22[iy+i] * g1[iz+i];
s[96] += g9[ix+i] * g20[iy+i] * g2[iz+i];
s[97] += g8[ix+i] * g21[iy+i] * g2[iz+i];
s[98] += g8[ix+i] * g20[iy+i] * g3[iz+i];
s[99] += g11[ix+i] * g16[iy+i] * g4[iz+i];
s[100] += g10[ix+i] * g17[iy+i] * g4[iz+i];
s[101] += g10[ix+i] * g16[iy+i] * g5[iz+i];
s[102] += g9[ix+i] * g18[iy+i] * g4[iz+i];
s[103] += g8[ix+i] * g19[iy+i] * g4[iz+i];
s[104] += g8[ix+i] * g18[iy+i] * g5[iz+i];
s[105] += g9[ix+i] * g16[iy+i] * g6[iz+i];
s[106] += g8[ix+i] * g17[iy+i] * g6[iz+i];
s[107] += g8[ix+i] * g16[iy+i] * g7[iz+i];
s[108] += g7[ix+i] * g24[iy+i] * g0[iz+i];
s[109] += g6[ix+i] * g25[iy+i] * g0[iz+i];
s[110] += g6[ix+i] * g24[iy+i] * g1[iz+i];
s[111] += g5[ix+i] * g26[iy+i] * g0[iz+i];
s[112] += g4[ix+i] * g27[iy+i] * g0[iz+i];
s[113] += g4[ix+i] * g26[iy+i] * g1[iz+i];
s[114] += g5[ix+i] * g24[iy+i] * g2[iz+i];
s[115] += g4[ix+i] * g25[iy+i] * g2[iz+i];
s[116] += g4[ix+i] * g24[iy+i] * g3[iz+i];
s[117] += g3[ix+i] * g28[iy+i] * g0[iz+i];
s[118] += g2[ix+i] * g29[iy+i] * g0[iz+i];
s[119] += g2[ix+i] * g28[iy+i] * g1[iz+i];
s[120] += g1[ix+i] * g30[iy+i] * g0[iz+i];
s[121] += g0[ix+i] * g31[iy+i] * g0[iz+i];
s[122] += g0[ix+i] * g30[iy+i] * g1[iz+i];
s[123] += g1[ix+i] * g28[iy+i] * g2[iz+i];
s[124] += g0[ix+i] * g29[iy+i] * g2[iz+i];
s[125] += g0[ix+i] * g28[iy+i] * g3[iz+i];
s[126] += g3[ix+i] * g24[iy+i] * g4[iz+i];
s[127] += g2[ix+i] * g25[iy+i] * g4[iz+i];
s[128] += g2[ix+i] * g24[iy+i] * g5[iz+i];
s[129] += g1[ix+i] * g26[iy+i] * g4[iz+i];
s[130] += g0[ix+i] * g27[iy+i] * g4[iz+i];
s[131] += g0[ix+i] * g26[iy+i] * g5[iz+i];
s[132] += g1[ix+i] * g24[iy+i] * g6[iz+i];
s[133] += g0[ix+i] * g25[iy+i] * g6[iz+i];
s[134] += g0[ix+i] * g24[iy+i] * g7[iz+i];
s[135] += g7[ix+i] * g16[iy+i] * g8[iz+i];
s[136] += g6[ix+i] * g17[iy+i] * g8[iz+i];
s[137] += g6[ix+i] * g16[iy+i] * g9[iz+i];
s[138] += g5[ix+i] * g18[iy+i] * g8[iz+i];
s[139] += g4[ix+i] * g19[iy+i] * g8[iz+i];
s[140] += g4[ix+i] * g18[iy+i] * g9[iz+i];
s[141] += g5[ix+i] * g16[iy+i] * g10[iz+i];
s[142] += g4[ix+i] * g17[iy+i] * g10[iz+i];
s[143] += g4[ix+i] * g16[iy+i] * g11[iz+i];
s[144] += g3[ix+i] * g20[iy+i] * g8[iz+i];
s[145] += g2[ix+i] * g21[iy+i] * g8[iz+i];
s[146] += g2[ix+i] * g20[iy+i] * g9[iz+i];
s[147] += g1[ix+i] * g22[iy+i] * g8[iz+i];
s[148] += g0[ix+i] * g23[iy+i] * g8[iz+i];
s[149] += g0[ix+i] * g22[iy+i] * g9[iz+i];
s[150] += g1[ix+i] * g20[iy+i] * g10[iz+i];
s[151] += g0[ix+i] * g21[iy+i] * g10[iz+i];
s[152] += g0[ix+i] * g20[iy+i] * g11[iz+i];
s[153] += g3[ix+i] * g16[iy+i] * g12[iz+i];
s[154] += g2[ix+i] * g17[iy+i] * g12[iz+i];
s[155] += g2[ix+i] * g16[iy+i] * g13[iz+i];
s[156] += g1[ix+i] * g18[iy+i] * g12[iz+i];
s[157] += g0[ix+i] * g19[iy+i] * g12[iz+i];
s[158] += g0[ix+i] * g18[iy+i] * g13[iz+i];
s[159] += g1[ix+i] * g16[iy+i] * g14[iz+i];
s[160] += g0[ix+i] * g17[iy+i] * g14[iz+i];
s[161] += g0[ix+i] * g16[iy+i] * g15[iz+i];
s[162] += g15[ix+i] * g0[iy+i] * g16[iz+i];
s[163] += g14[ix+i] * g1[iy+i] * g16[iz+i];
s[164] += g14[ix+i] * g0[iy+i] * g17[iz+i];
s[165] += g13[ix+i] * g2[iy+i] * g16[iz+i];
s[166] += g12[ix+i] * g3[iy+i] * g16[iz+i];
s[167] += g12[ix+i] * g2[iy+i] * g17[iz+i];
s[168] += g13[ix+i] * g0[iy+i] * g18[iz+i];
s[169] += g12[ix+i] * g1[iy+i] * g18[iz+i];
s[170] += g12[ix+i] * g0[iy+i] * g19[iz+i];
s[171] += g11[ix+i] * g4[iy+i] * g16[iz+i];
s[172] += g10[ix+i] * g5[iy+i] * g16[iz+i];
s[173] += g10[ix+i] * g4[iy+i] * g17[iz+i];
s[174] += g9[ix+i] * g6[iy+i] * g16[iz+i];
s[175] += g8[ix+i] * g7[iy+i] * g16[iz+i];
s[176] += g8[ix+i] * g6[iy+i] * g17[iz+i];
s[177] += g9[ix+i] * g4[iy+i] * g18[iz+i];
s[178] += g8[ix+i] * g5[iy+i] * g18[iz+i];
s[179] += g8[ix+i] * g4[iy+i] * g19[iz+i];
s[180] += g11[ix+i] * g0[iy+i] * g20[iz+i];
s[181] += g10[ix+i] * g1[iy+i] * g20[iz+i];
s[182] += g10[ix+i] * g0[iy+i] * g21[iz+i];
s[183] += g9[ix+i] * g2[iy+i] * g20[iz+i];
s[184] += g8[ix+i] * g3[iy+i] * g20[iz+i];
s[185] += g8[ix+i] * g2[iy+i] * g21[iz+i];
s[186] += g9[ix+i] * g0[iy+i] * g22[iz+i];
s[187] += g8[ix+i] * g1[iy+i] * g22[iz+i];
s[188] += g8[ix+i] * g0[iy+i] * g23[iz+i];
s[189] += g7[ix+i] * g8[iy+i] * g16[iz+i];
s[190] += g6[ix+i] * g9[iy+i] * g16[iz+i];
s[191] += g6[ix+i] * g8[iy+i] * g17[iz+i];
s[192] += g5[ix+i] * g10[iy+i] * g16[iz+i];
s[193] += g4[ix+i] * g11[iy+i] * g16[iz+i];
s[194] += g4[ix+i] * g10[iy+i] * g17[iz+i];
s[195] += g5[ix+i] * g8[iy+i] * g18[iz+i];
s[196] += g4[ix+i] * g9[iy+i] * g18[iz+i];
s[197] += g4[ix+i] * g8[iy+i] * g19[iz+i];
s[198] += g3[ix+i] * g12[iy+i] * g16[iz+i];
s[199] += g2[ix+i] * g13[iy+i] * g16[iz+i];
s[200] += g2[ix+i] * g12[iy+i] * g17[iz+i];
s[201] += g1[ix+i] * g14[iy+i] * g16[iz+i];
s[202] += g0[ix+i] * g15[iy+i] * g16[iz+i];
s[203] += g0[ix+i] * g14[iy+i] * g17[iz+i];
s[204] += g1[ix+i] * g12[iy+i] * g18[iz+i];
s[205] += g0[ix+i] * g13[iy+i] * g18[iz+i];
s[206] += g0[ix+i] * g12[iy+i] * g19[iz+i];
s[207] += g3[ix+i] * g8[iy+i] * g20[iz+i];
s[208] += g2[ix+i] * g9[iy+i] * g20[iz+i];
s[209] += g2[ix+i] * g8[iy+i] * g21[iz+i];
s[210] += g1[ix+i] * g10[iy+i] * g20[iz+i];
s[211] += g0[ix+i] * g11[iy+i] * g20[iz+i];
s[212] += g0[ix+i] * g10[iy+i] * g21[iz+i];
s[213] += g1[ix+i] * g8[iy+i] * g22[iz+i];
s[214] += g0[ix+i] * g9[iy+i] * g22[iz+i];
s[215] += g0[ix+i] * g8[iy+i] * g23[iz+i];
s[216] += g7[ix+i] * g0[iy+i] * g24[iz+i];
s[217] += g6[ix+i] * g1[iy+i] * g24[iz+i];
s[218] += g6[ix+i] * g0[iy+i] * g25[iz+i];
s[219] += g5[ix+i] * g2[iy+i] * g24[iz+i];
s[220] += g4[ix+i] * g3[iy+i] * g24[iz+i];
s[221] += g4[ix+i] * g2[iy+i] * g25[iz+i];
s[222] += g5[ix+i] * g0[iy+i] * g26[iz+i];
s[223] += g4[ix+i] * g1[iy+i] * g26[iz+i];
s[224] += g4[ix+i] * g0[iy+i] * g27[iz+i];
s[225] += g3[ix+i] * g4[iy+i] * g24[iz+i];
s[226] += g2[ix+i] * g5[iy+i] * g24[iz+i];
s[227] += g2[ix+i] * g4[iy+i] * g25[iz+i];
s[228] += g1[ix+i] * g6[iy+i] * g24[iz+i];
s[229] += g0[ix+i] * g7[iy+i] * g24[iz+i];
s[230] += g0[ix+i] * g6[iy+i] * g25[iz+i];
s[231] += g1[ix+i] * g4[iy+i] * g26[iz+i];
s[232] += g0[ix+i] * g5[iy+i] * g26[iz+i];
s[233] += g0[ix+i] * g4[iy+i] * g27[iz+i];
s[234] += g3[ix+i] * g0[iy+i] * g28[iz+i];
s[235] += g2[ix+i] * g1[iy+i] * g28[iz+i];
s[236] += g2[ix+i] * g0[iy+i] * g29[iz+i];
s[237] += g1[ix+i] * g2[iy+i] * g28[iz+i];
s[238] += g0[ix+i] * g3[iy+i] * g28[iz+i];
s[239] += g0[ix+i] * g2[iy+i] * g29[iz+i];
s[240] += g1[ix+i] * g0[iy+i] * g30[iz+i];
s[241] += g0[ix+i] * g1[iy+i] * g30[iz+i];
s[242] += g0[ix+i] * g0[iy+i] * g31[iz+i];
}
gout[n*48+0] = + s[104] - s[176] - s[106] + s[178];
gout[n*48+1] = + s[167] - s[23] - s[169] + s[25];
gout[n*48+2] = + s[14] - s[86] - s[16] + s[88];
gout[n*48+3] = + s[5] + s[95] + s[185] - s[7] - s[97] - s[187];
gout[n*48+4] = + s[105] - s[177] - s[101] + s[173];
gout[n*48+5] = + s[168] - s[24] - s[164] + s[20];
gout[n*48+6] = + s[15] - s[87] - s[11] + s[83];
gout[n*48+7] = + s[6] + s[96] + s[186] - s[2] - s[92] - s[182];
gout[n*48+8] = + s[100] - s[172] - s[102] + s[174];
gout[n*48+9] = + s[163] - s[19] - s[165] + s[21];
gout[n*48+10] = + s[10] - s[82] - s[12] + s[84];
gout[n*48+11] = + s[1] + s[91] + s[181] - s[3] - s[93] - s[183];
gout[n*48+12] = + s[99] - s[171] + s[103] - s[175] + s[107] - s[179];
gout[n*48+13] = + s[162] - s[18] + s[166] - s[22] + s[170] - s[26];
gout[n*48+14] = + s[9] - s[81] + s[13] - s[85] + s[17] - s[89];
gout[n*48+15] = + s[0] + s[90] + s[180] + s[4] + s[94] + s[184] + s[8] + s[98] + s[188];
gout[n*48+16] = + s[131] - s[203] - s[133] + s[205];
gout[n*48+17] = + s[194] - s[50] - s[196] + s[52];
gout[n*48+18] = + s[41] - s[113] - s[43] + s[115];
gout[n*48+19] = + s[32] + s[122] + s[212] - s[34] - s[124] - s[214];
gout[n*48+20] = + s[132] - s[204] - s[128] + s[200];
gout[n*48+21] = + s[195] - s[51] - s[191] + s[47];
gout[n*48+22] = + s[42] - s[114] - s[38] + s[110];
gout[n*48+23] = + s[33] + s[123] + s[213] - s[29] - s[119] - s[209];
gout[n*48+24] = + s[127] - s[199] - s[129] + s[201];
gout[n*48+25] = + s[190] - s[46] - s[192] + s[48];
gout[n*48+26] = + s[37] - s[109] - s[39] + s[111];
gout[n*48+27] = + s[28] + s[118] + s[208] - s[30] - s[120] - s[210];
gout[n*48+28] = + s[126] - s[198] + s[130] - s[202] + s[134] - s[206];
gout[n*48+29] = + s[189] - s[45] + s[193] - s[49] + s[197] - s[53];
gout[n*48+30] = + s[36] - s[108] + s[40] - s[112] + s[44] - s[116];
gout[n*48+31] = + s[27] + s[117] + s[207] + s[31] + s[121] + s[211] + s[35] + s[125] + s[215];
gout[n*48+32] = + s[158] - s[230] - s[160] + s[232];
gout[n*48+33] = + s[221] - s[77] - s[223] + s[79];
gout[n*48+34] = + s[68] - s[140] - s[70] + s[142];
gout[n*48+35] = + s[59] + s[149] + s[239] - s[61] - s[151] - s[241];
gout[n*48+36] = + s[159] - s[231] - s[155] + s[227];
gout[n*48+37] = + s[222] - s[78] - s[218] + s[74];
gout[n*48+38] = + s[69] - s[141] - s[65] + s[137];
gout[n*48+39] = + s[60] + s[150] + s[240] - s[56] - s[146] - s[236];
gout[n*48+40] = + s[154] - s[226] - s[156] + s[228];
gout[n*48+41] = + s[217] - s[73] - s[219] + s[75];
gout[n*48+42] = + s[64] - s[136] - s[66] + s[138];
gout[n*48+43] = + s[55] + s[145] + s[235] - s[57] - s[147] - s[237];
gout[n*48+44] = + s[153] - s[225] + s[157] - s[229] + s[161] - s[233];
gout[n*48+45] = + s[216] - s[72] + s[220] - s[76] + s[224] - s[80];
gout[n*48+46] = + s[63] - s[135] + s[67] - s[139] + s[71] - s[143];
gout[n*48+47] = + s[54] + s[144] + s[234] + s[58] + s[148] + s[238] + s[62] + s[152] + s[242];
}}
void int2e_ipspsp1spsp2_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ipspsp1spsp2_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipspsp1spsp2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipspsp1spsp2_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ipspsp1spsp2_cart
int int2e_ipspsp1spsp2_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipspsp1spsp2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipspsp1spsp2_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ipspsp1spsp2_sph
int int2e_ipspsp1spsp2_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipspsp1spsp2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipspsp1spsp2_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_2e1, &c2s_si_2e2);
} // int2e_ipspsp1spsp2_spinor
ALL_CINT(int2e_ipspsp1spsp2)
//ALL_CINT_FORTRAN_(cint2e_ipspsp1spsp2)
/* <k NABLA SIGMA DOT R i|R12 |SIGMA DOT R j l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT R i SIGMA DOT R j|R12 |k l) */
void CINTgout2e_int2e_ipsrsr1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 12;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_R_J(g1, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I(g2, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g3, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
}
r1 = + rs[11] - rs[19]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = + rs[18] - rs[2]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = + rs[1] - rs[9]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[0] + rs[10] + rs[20]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = + rs[14] - rs[22]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[21] - rs[5]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = + rs[4] - rs[12]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = + rs[3] + rs[13] + rs[23]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = + rs[17] - rs[25]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = + rs[24] - rs[8]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[7] - rs[15]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[6] + rs[16] + rs[26]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void CINTgout2e_int2e_ipsrsr1_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_R_J_SIMD1(g1, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g2, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g3, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
gout[n*12+0] = + s[11] - s[19];
gout[n*12+1] = + s[18] - s[2];
gout[n*12+2] = + s[1] - s[9];
gout[n*12+3] = + s[0] + s[10] + s[20];
gout[n*12+4] = + s[14] - s[22];
gout[n*12+5] = + s[21] - s[5];
gout[n*12+6] = + s[4] - s[12];
gout[n*12+7] = + s[3] + s[13] + s[23];
gout[n*12+8] = + s[17] - s[25];
gout[n*12+9] = + s[24] - s[8];
gout[n*12+10] = + s[7] - s[15];
gout[n*12+11] = + s[6] + s[16] + s[26];
}}
void int2e_ipsrsr1_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ipsrsr1_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipsrsr1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipsrsr1_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ipsrsr1_cart
int int2e_ipsrsr1_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipsrsr1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipsrsr1_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ipsrsr1_sph
int int2e_ipsrsr1_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 0, 0, 3, 4, 1, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipsrsr1;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipsrsr1_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_2e1, &c2s_sf_2e2);
} // int2e_ipsrsr1_spinor
ALL_CINT(int2e_ipsrsr1)
//ALL_CINT_FORTRAN_(cint2e_ipsrsr1)
/* <SIGMA DOT R k NABLA i|R12 |j SIGMA DOT R l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA i j|R12 |SIGMA DOT R k SIGMA DOT R l) */
void CINTgout2e_int2e_ip1srsr2(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 12;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_R_L(g1, g0, envs->i_l+1, envs->j_l+0, envs->k_l+1, envs->l_l+0);
G2E_R_K(g2, g0, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_R_K(g3, g1, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_D_I(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
}
r1 = + rs[5] - rs[7]; GOUT_SCATTER(gout, n*12+0, r1);
r1 = + rs[6] - rs[2]; GOUT_SCATTER(gout, n*12+1, r1);
r1 = + rs[1] - rs[3]; GOUT_SCATTER(gout, n*12+2, r1);
r1 = + rs[0] + rs[4] + rs[8]; GOUT_SCATTER(gout, n*12+3, r1);
r1 = + rs[14] - rs[16]; GOUT_SCATTER(gout, n*12+4, r1);
r1 = + rs[15] - rs[11]; GOUT_SCATTER(gout, n*12+5, r1);
r1 = + rs[10] - rs[12]; GOUT_SCATTER(gout, n*12+6, r1);
r1 = + rs[9] + rs[13] + rs[17]; GOUT_SCATTER(gout, n*12+7, r1);
r1 = + rs[23] - rs[25]; GOUT_SCATTER(gout, n*12+8, r1);
r1 = + rs[24] - rs[20]; GOUT_SCATTER(gout, n*12+9, r1);
r1 = + rs[19] - rs[21]; GOUT_SCATTER(gout, n*12+10, r1);
r1 = + rs[18] + rs[22] + rs[26]; GOUT_SCATTER(gout, n*12+11, r1);
}}
void CINTgout2e_int2e_ip1srsr2_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
G2E_R_L_SIMD1(g1, g0, envs->i_l+1, envs->j_l+0, envs->k_l+1, envs->l_l+0);
G2E_R_K_SIMD1(g2, g0, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_R_K_SIMD1(g3, g1, envs->i_l+1, envs->j_l+0, envs->k_l+0, envs->l_l);
G2E_D_I_SIMD1(g4, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g5, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g6, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g7, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[27];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 27; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g7[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g6[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g6[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g5[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g4[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g4[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g5[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g4[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g4[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g3[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g2[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g2[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g1[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g0[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g0[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g1[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g0[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g0[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g3[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g2[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g2[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g1[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g0[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g0[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g1[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g0[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g0[ix+i] * g0[iy+i] * g7[iz+i];
}
gout[n*12+0] = + s[5] - s[7];
gout[n*12+1] = + s[6] - s[2];
gout[n*12+2] = + s[1] - s[3];
gout[n*12+3] = + s[0] + s[4] + s[8];
gout[n*12+4] = + s[14] - s[16];
gout[n*12+5] = + s[15] - s[11];
gout[n*12+6] = + s[10] - s[12];
gout[n*12+7] = + s[9] + s[13] + s[17];
gout[n*12+8] = + s[23] - s[25];
gout[n*12+9] = + s[24] - s[20];
gout[n*12+10] = + s[19] - s[21];
gout[n*12+11] = + s[18] + s[22] + s[26];
}}
void int2e_ip1srsr2_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ip1srsr2_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1srsr2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1srsr2_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ip1srsr2_cart
int int2e_ip1srsr2_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1srsr2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1srsr2_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ip1srsr2_sph
int int2e_ip1srsr2_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {1, 0, 1, 1, 3, 1, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ip1srsr2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ip1srsr2_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_sf_2e1, &c2s_si_2e2);
} // int2e_ip1srsr2_spinor
ALL_CINT(int2e_ip1srsr2)
//ALL_CINT_FORTRAN_(cint2e_ip1srsr2)
/* <SIGMA DOT R k NABLA SIGMA DOT R i|R12 |SIGMA DOT R j SIGMA DOT R l> : i,j \in electron 1; k,l \in electron 2
 * = (NABLA SIGMA DOT R i SIGMA DOT R j|R12 |SIGMA DOT R k SIGMA DOT R l) */
void CINTgout2e_int2e_ipsrsr1srsr2(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nfc = nf * 48;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
DECLARE_GOUT;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
double *RESTRICT g8 = g7 + envs->g_size * 3 * SIMDD;
double *RESTRICT g9 = g8 + envs->g_size * 3 * SIMDD;
double *RESTRICT g10 = g9 + envs->g_size * 3 * SIMDD;
double *RESTRICT g11 = g10 + envs->g_size * 3 * SIMDD;
double *RESTRICT g12 = g11 + envs->g_size * 3 * SIMDD;
double *RESTRICT g13 = g12 + envs->g_size * 3 * SIMDD;
double *RESTRICT g14 = g13 + envs->g_size * 3 * SIMDD;
double *RESTRICT g15 = g14 + envs->g_size * 3 * SIMDD;
double *RESTRICT g16 = g15 + envs->g_size * 3 * SIMDD;
double *RESTRICT g17 = g16 + envs->g_size * 3 * SIMDD;
double *RESTRICT g18 = g17 + envs->g_size * 3 * SIMDD;
double *RESTRICT g19 = g18 + envs->g_size * 3 * SIMDD;
double *RESTRICT g20 = g19 + envs->g_size * 3 * SIMDD;
double *RESTRICT g21 = g20 + envs->g_size * 3 * SIMDD;
double *RESTRICT g22 = g21 + envs->g_size * 3 * SIMDD;
double *RESTRICT g23 = g22 + envs->g_size * 3 * SIMDD;
double *RESTRICT g24 = g23 + envs->g_size * 3 * SIMDD;
double *RESTRICT g25 = g24 + envs->g_size * 3 * SIMDD;
double *RESTRICT g26 = g25 + envs->g_size * 3 * SIMDD;
double *RESTRICT g27 = g26 + envs->g_size * 3 * SIMDD;
double *RESTRICT g28 = g27 + envs->g_size * 3 * SIMDD;
double *RESTRICT g29 = g28 + envs->g_size * 3 * SIMDD;
double *RESTRICT g30 = g29 + envs->g_size * 3 * SIMDD;
double *RESTRICT g31 = g30 + envs->g_size * 3 * SIMDD;
G2E_R_L(g1, g0, envs->i_l+2, envs->j_l+1, envs->k_l+1, envs->l_l+0);
G2E_R_K(g2, g0, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_R_K(g3, g1, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_R_J(g4, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_R_J(g5, g1, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_R_J(g6, g2, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_R_J(g7, g3, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I(g8, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g9, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g10, g2, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g11, g3, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g12, g4, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g13, g5, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g14, g6, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I(g15, g7, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g16, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g17, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g18, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g19, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g20, g4, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g21, g5, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g22, g6, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g23, g7, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g24, g8, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g25, g9, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g26, g10, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g27, g11, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g28, g12, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g29, g13, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g30, g14, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I(g31, g15, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
__MD r1;
__MD rs[243];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 243; i++) { rs[i] = MM_SET1(0.); }
for (i = 0; i < nrys_roots; i++) {
rs[0] += MM_LOAD(g31+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[1] += MM_LOAD(g30+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[2] += MM_LOAD(g30+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[3] += MM_LOAD(g29+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[4] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[5] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[6] += MM_LOAD(g29+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[7] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[8] += MM_LOAD(g28+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[9] += MM_LOAD(g27+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[10] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[11] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[12] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[13] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[14] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[15] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[16] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[17] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[18] += MM_LOAD(g27+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[19] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[20] += MM_LOAD(g26+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[21] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[22] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[23] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[24] += MM_LOAD(g25+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[25] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[26] += MM_LOAD(g24+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[27] += MM_LOAD(g23+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[28] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[29] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[30] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[31] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[32] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[33] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[34] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[35] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[36] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[37] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[38] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[39] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[40] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g15+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[41] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[42] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[43] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[44] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[45] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[46] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[47] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[48] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[49] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[50] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[51] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[52] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[53] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[54] += MM_LOAD(g23+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[55] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[56] += MM_LOAD(g22+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[57] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[58] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[59] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[60] += MM_LOAD(g21+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[61] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[62] += MM_LOAD(g20+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[63] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[64] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[65] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[66] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[67] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[68] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[69] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[70] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[71] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[72] += MM_LOAD(g19+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[73] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[74] += MM_LOAD(g18+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[75] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[76] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[77] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[78] += MM_LOAD(g17+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[79] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[80] += MM_LOAD(g16+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g15+(iz+i)*SIMDD);
rs[81] += MM_LOAD(g15+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[82] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[83] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[84] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[85] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[86] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[87] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[88] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[89] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[90] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[91] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[92] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[93] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[94] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g23+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[95] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[96] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[97] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[98] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[99] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[100] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[101] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[102] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[103] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[104] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[105] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[106] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[107] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[108] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[109] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[110] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[111] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[112] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g27+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[113] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[114] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[115] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[116] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[117] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[118] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g29+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[119] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[120] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g30+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[121] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g31+(iy+i)*SIMDD) * MM_LOAD(g0+(iz+i)*SIMDD);
rs[122] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g30+(iy+i)*SIMDD) * MM_LOAD(g1+(iz+i)*SIMDD);
rs[123] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[124] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g29+(iy+i)*SIMDD) * MM_LOAD(g2+(iz+i)*SIMDD);
rs[125] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g28+(iy+i)*SIMDD) * MM_LOAD(g3+(iz+i)*SIMDD);
rs[126] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[127] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[128] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[129] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[130] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g27+(iy+i)*SIMDD) * MM_LOAD(g4+(iz+i)*SIMDD);
rs[131] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g26+(iy+i)*SIMDD) * MM_LOAD(g5+(iz+i)*SIMDD);
rs[132] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[133] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g25+(iy+i)*SIMDD) * MM_LOAD(g6+(iz+i)*SIMDD);
rs[134] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g24+(iy+i)*SIMDD) * MM_LOAD(g7+(iz+i)*SIMDD);
rs[135] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[136] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[137] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[138] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[139] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[140] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[141] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[142] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[143] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[144] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[145] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[146] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[147] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[148] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g23+(iy+i)*SIMDD) * MM_LOAD(g8+(iz+i)*SIMDD);
rs[149] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g22+(iy+i)*SIMDD) * MM_LOAD(g9+(iz+i)*SIMDD);
rs[150] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[151] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g21+(iy+i)*SIMDD) * MM_LOAD(g10+(iz+i)*SIMDD);
rs[152] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g20+(iy+i)*SIMDD) * MM_LOAD(g11+(iz+i)*SIMDD);
rs[153] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[154] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[155] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[156] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[157] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g19+(iy+i)*SIMDD) * MM_LOAD(g12+(iz+i)*SIMDD);
rs[158] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g18+(iy+i)*SIMDD) * MM_LOAD(g13+(iz+i)*SIMDD);
rs[159] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[160] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g17+(iy+i)*SIMDD) * MM_LOAD(g14+(iz+i)*SIMDD);
rs[161] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g16+(iy+i)*SIMDD) * MM_LOAD(g15+(iz+i)*SIMDD);
rs[162] += MM_LOAD(g15+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[163] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[164] += MM_LOAD(g14+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[165] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[166] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[167] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[168] += MM_LOAD(g13+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[169] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[170] += MM_LOAD(g12+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[171] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[172] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[173] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[174] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[175] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[176] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[177] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[178] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[179] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[180] += MM_LOAD(g11+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[181] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[182] += MM_LOAD(g10+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[183] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[184] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[185] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[186] += MM_LOAD(g9+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[187] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[188] += MM_LOAD(g8+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g23+(iz+i)*SIMDD);
rs[189] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[190] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[191] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[192] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[193] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[194] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[195] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[196] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[197] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[198] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[199] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[200] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[201] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[202] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g15+(iy+i)*SIMDD) * MM_LOAD(g16+(iz+i)*SIMDD);
rs[203] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g14+(iy+i)*SIMDD) * MM_LOAD(g17+(iz+i)*SIMDD);
rs[204] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[205] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g13+(iy+i)*SIMDD) * MM_LOAD(g18+(iz+i)*SIMDD);
rs[206] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g12+(iy+i)*SIMDD) * MM_LOAD(g19+(iz+i)*SIMDD);
rs[207] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[208] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[209] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[210] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[211] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g11+(iy+i)*SIMDD) * MM_LOAD(g20+(iz+i)*SIMDD);
rs[212] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g10+(iy+i)*SIMDD) * MM_LOAD(g21+(iz+i)*SIMDD);
rs[213] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[214] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g9+(iy+i)*SIMDD) * MM_LOAD(g22+(iz+i)*SIMDD);
rs[215] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g8+(iy+i)*SIMDD) * MM_LOAD(g23+(iz+i)*SIMDD);
rs[216] += MM_LOAD(g7+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[217] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[218] += MM_LOAD(g6+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[219] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[220] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[221] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[222] += MM_LOAD(g5+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[223] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[224] += MM_LOAD(g4+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g27+(iz+i)*SIMDD);
rs[225] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[226] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[227] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[228] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[229] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g7+(iy+i)*SIMDD) * MM_LOAD(g24+(iz+i)*SIMDD);
rs[230] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g6+(iy+i)*SIMDD) * MM_LOAD(g25+(iz+i)*SIMDD);
rs[231] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[232] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g5+(iy+i)*SIMDD) * MM_LOAD(g26+(iz+i)*SIMDD);
rs[233] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g4+(iy+i)*SIMDD) * MM_LOAD(g27+(iz+i)*SIMDD);
rs[234] += MM_LOAD(g3+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[235] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[236] += MM_LOAD(g2+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g29+(iz+i)*SIMDD);
rs[237] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[238] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g3+(iy+i)*SIMDD) * MM_LOAD(g28+(iz+i)*SIMDD);
rs[239] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g2+(iy+i)*SIMDD) * MM_LOAD(g29+(iz+i)*SIMDD);
rs[240] += MM_LOAD(g1+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g30+(iz+i)*SIMDD);
rs[241] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g1+(iy+i)*SIMDD) * MM_LOAD(g30+(iz+i)*SIMDD);
rs[242] += MM_LOAD(g0+(ix+i)*SIMDD) * MM_LOAD(g0+(iy+i)*SIMDD) * MM_LOAD(g31+(iz+i)*SIMDD);
}
r1 = + rs[104] - rs[176] - rs[106] + rs[178]; GOUT_SCATTER(gout, n*48+0, r1);
r1 = + rs[167] - rs[23] - rs[169] + rs[25]; GOUT_SCATTER(gout, n*48+1, r1);
r1 = + rs[14] - rs[86] - rs[16] + rs[88]; GOUT_SCATTER(gout, n*48+2, r1);
r1 = + rs[5] + rs[95] + rs[185] - rs[7] - rs[97] - rs[187]; GOUT_SCATTER(gout, n*48+3, r1);
r1 = + rs[105] - rs[177] - rs[101] + rs[173]; GOUT_SCATTER(gout, n*48+4, r1);
r1 = + rs[168] - rs[24] - rs[164] + rs[20]; GOUT_SCATTER(gout, n*48+5, r1);
r1 = + rs[15] - rs[87] - rs[11] + rs[83]; GOUT_SCATTER(gout, n*48+6, r1);
r1 = + rs[6] + rs[96] + rs[186] - rs[2] - rs[92] - rs[182]; GOUT_SCATTER(gout, n*48+7, r1);
r1 = + rs[100] - rs[172] - rs[102] + rs[174]; GOUT_SCATTER(gout, n*48+8, r1);
r1 = + rs[163] - rs[19] - rs[165] + rs[21]; GOUT_SCATTER(gout, n*48+9, r1);
r1 = + rs[10] - rs[82] - rs[12] + rs[84]; GOUT_SCATTER(gout, n*48+10, r1);
r1 = + rs[1] + rs[91] + rs[181] - rs[3] - rs[93] - rs[183]; GOUT_SCATTER(gout, n*48+11, r1);
r1 = + rs[99] - rs[171] + rs[103] - rs[175] + rs[107] - rs[179]; GOUT_SCATTER(gout, n*48+12, r1);
r1 = + rs[162] - rs[18] + rs[166] - rs[22] + rs[170] - rs[26]; GOUT_SCATTER(gout, n*48+13, r1);
r1 = + rs[9] - rs[81] + rs[13] - rs[85] + rs[17] - rs[89]; GOUT_SCATTER(gout, n*48+14, r1);
r1 = + rs[0] + rs[90] + rs[180] + rs[4] + rs[94] + rs[184] + rs[8] + rs[98] + rs[188]; GOUT_SCATTER(gout, n*48+15, r1);
r1 = + rs[131] - rs[203] - rs[133] + rs[205]; GOUT_SCATTER(gout, n*48+16, r1);
r1 = + rs[194] - rs[50] - rs[196] + rs[52]; GOUT_SCATTER(gout, n*48+17, r1);
r1 = + rs[41] - rs[113] - rs[43] + rs[115]; GOUT_SCATTER(gout, n*48+18, r1);
r1 = + rs[32] + rs[122] + rs[212] - rs[34] - rs[124] - rs[214]; GOUT_SCATTER(gout, n*48+19, r1);
r1 = + rs[132] - rs[204] - rs[128] + rs[200]; GOUT_SCATTER(gout, n*48+20, r1);
r1 = + rs[195] - rs[51] - rs[191] + rs[47]; GOUT_SCATTER(gout, n*48+21, r1);
r1 = + rs[42] - rs[114] - rs[38] + rs[110]; GOUT_SCATTER(gout, n*48+22, r1);
r1 = + rs[33] + rs[123] + rs[213] - rs[29] - rs[119] - rs[209]; GOUT_SCATTER(gout, n*48+23, r1);
r1 = + rs[127] - rs[199] - rs[129] + rs[201]; GOUT_SCATTER(gout, n*48+24, r1);
r1 = + rs[190] - rs[46] - rs[192] + rs[48]; GOUT_SCATTER(gout, n*48+25, r1);
r1 = + rs[37] - rs[109] - rs[39] + rs[111]; GOUT_SCATTER(gout, n*48+26, r1);
r1 = + rs[28] + rs[118] + rs[208] - rs[30] - rs[120] - rs[210]; GOUT_SCATTER(gout, n*48+27, r1);
r1 = + rs[126] - rs[198] + rs[130] - rs[202] + rs[134] - rs[206]; GOUT_SCATTER(gout, n*48+28, r1);
r1 = + rs[189] - rs[45] + rs[193] - rs[49] + rs[197] - rs[53]; GOUT_SCATTER(gout, n*48+29, r1);
r1 = + rs[36] - rs[108] + rs[40] - rs[112] + rs[44] - rs[116]; GOUT_SCATTER(gout, n*48+30, r1);
r1 = + rs[27] + rs[117] + rs[207] + rs[31] + rs[121] + rs[211] + rs[35] + rs[125] + rs[215]; GOUT_SCATTER(gout, n*48+31, r1);
r1 = + rs[158] - rs[230] - rs[160] + rs[232]; GOUT_SCATTER(gout, n*48+32, r1);
r1 = + rs[221] - rs[77] - rs[223] + rs[79]; GOUT_SCATTER(gout, n*48+33, r1);
r1 = + rs[68] - rs[140] - rs[70] + rs[142]; GOUT_SCATTER(gout, n*48+34, r1);
r1 = + rs[59] + rs[149] + rs[239] - rs[61] - rs[151] - rs[241]; GOUT_SCATTER(gout, n*48+35, r1);
r1 = + rs[159] - rs[231] - rs[155] + rs[227]; GOUT_SCATTER(gout, n*48+36, r1);
r1 = + rs[222] - rs[78] - rs[218] + rs[74]; GOUT_SCATTER(gout, n*48+37, r1);
r1 = + rs[69] - rs[141] - rs[65] + rs[137]; GOUT_SCATTER(gout, n*48+38, r1);
r1 = + rs[60] + rs[150] + rs[240] - rs[56] - rs[146] - rs[236]; GOUT_SCATTER(gout, n*48+39, r1);
r1 = + rs[154] - rs[226] - rs[156] + rs[228]; GOUT_SCATTER(gout, n*48+40, r1);
r1 = + rs[217] - rs[73] - rs[219] + rs[75]; GOUT_SCATTER(gout, n*48+41, r1);
r1 = + rs[64] - rs[136] - rs[66] + rs[138]; GOUT_SCATTER(gout, n*48+42, r1);
r1 = + rs[55] + rs[145] + rs[235] - rs[57] - rs[147] - rs[237]; GOUT_SCATTER(gout, n*48+43, r1);
r1 = + rs[153] - rs[225] + rs[157] - rs[229] + rs[161] - rs[233]; GOUT_SCATTER(gout, n*48+44, r1);
r1 = + rs[216] - rs[72] + rs[220] - rs[76] + rs[224] - rs[80]; GOUT_SCATTER(gout, n*48+45, r1);
r1 = + rs[63] - rs[135] + rs[67] - rs[139] + rs[71] - rs[143]; GOUT_SCATTER(gout, n*48+46, r1);
r1 = + rs[54] + rs[144] + rs[234] + rs[58] + rs[148] + rs[238] + rs[62] + rs[152] + rs[242]; GOUT_SCATTER(gout, n*48+47, r1);
}}
void CINTgout2e_int2e_ipsrsr1srsr2_simd1(double *RESTRICT gout,
double *RESTRICT g, int *RESTRICT idx, CINTEnvVars *envs) {
int nf = envs->nf;
int nrys_roots = envs->nrys_roots;
int ix, iy, iz, i, n;
double *RESTRICT g0 = g;
double *RESTRICT g1 = g0 + envs->g_size * 3 * SIMDD;
double *RESTRICT g2 = g1 + envs->g_size * 3 * SIMDD;
double *RESTRICT g3 = g2 + envs->g_size * 3 * SIMDD;
double *RESTRICT g4 = g3 + envs->g_size * 3 * SIMDD;
double *RESTRICT g5 = g4 + envs->g_size * 3 * SIMDD;
double *RESTRICT g6 = g5 + envs->g_size * 3 * SIMDD;
double *RESTRICT g7 = g6 + envs->g_size * 3 * SIMDD;
double *RESTRICT g8 = g7 + envs->g_size * 3 * SIMDD;
double *RESTRICT g9 = g8 + envs->g_size * 3 * SIMDD;
double *RESTRICT g10 = g9 + envs->g_size * 3 * SIMDD;
double *RESTRICT g11 = g10 + envs->g_size * 3 * SIMDD;
double *RESTRICT g12 = g11 + envs->g_size * 3 * SIMDD;
double *RESTRICT g13 = g12 + envs->g_size * 3 * SIMDD;
double *RESTRICT g14 = g13 + envs->g_size * 3 * SIMDD;
double *RESTRICT g15 = g14 + envs->g_size * 3 * SIMDD;
double *RESTRICT g16 = g15 + envs->g_size * 3 * SIMDD;
double *RESTRICT g17 = g16 + envs->g_size * 3 * SIMDD;
double *RESTRICT g18 = g17 + envs->g_size * 3 * SIMDD;
double *RESTRICT g19 = g18 + envs->g_size * 3 * SIMDD;
double *RESTRICT g20 = g19 + envs->g_size * 3 * SIMDD;
double *RESTRICT g21 = g20 + envs->g_size * 3 * SIMDD;
double *RESTRICT g22 = g21 + envs->g_size * 3 * SIMDD;
double *RESTRICT g23 = g22 + envs->g_size * 3 * SIMDD;
double *RESTRICT g24 = g23 + envs->g_size * 3 * SIMDD;
double *RESTRICT g25 = g24 + envs->g_size * 3 * SIMDD;
double *RESTRICT g26 = g25 + envs->g_size * 3 * SIMDD;
double *RESTRICT g27 = g26 + envs->g_size * 3 * SIMDD;
double *RESTRICT g28 = g27 + envs->g_size * 3 * SIMDD;
double *RESTRICT g29 = g28 + envs->g_size * 3 * SIMDD;
double *RESTRICT g30 = g29 + envs->g_size * 3 * SIMDD;
double *RESTRICT g31 = g30 + envs->g_size * 3 * SIMDD;
G2E_R_L_SIMD1(g1, g0, envs->i_l+2, envs->j_l+1, envs->k_l+1, envs->l_l+0);
G2E_R_K_SIMD1(g2, g0, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_R_K_SIMD1(g3, g1, envs->i_l+2, envs->j_l+1, envs->k_l+0, envs->l_l);
G2E_R_J_SIMD1(g4, g0, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_R_J_SIMD1(g5, g1, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_R_J_SIMD1(g6, g2, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_R_J_SIMD1(g7, g3, envs->i_l+2, envs->j_l+0, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g8, g0, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g9, g1, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g10, g2, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g11, g3, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g12, g4, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g13, g5, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g14, g6, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_D_I_SIMD1(g15, g7, envs->i_l+1, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g16, g0, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g17, g1, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g18, g2, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g19, g3, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g20, g4, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g21, g5, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g22, g6, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g23, g7, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g24, g8, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g25, g9, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g26, g10, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g27, g11, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g28, g12, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g29, g13, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g30, g14, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
G2E_R_I_SIMD1(g31, g15, envs->i_l+0, envs->j_l, envs->k_l, envs->l_l);
double s[243];
for (n = 0; n < nf; n++) {
ix = idx[0+n*3];
iy = idx[1+n*3];
iz = idx[2+n*3];
for (i = 0; i < 243; i++) { s[i] = 0; }
for (i = 0; i < nrys_roots; i++) {
s[0] += g31[ix+i] * g0[iy+i] * g0[iz+i];
s[1] += g30[ix+i] * g1[iy+i] * g0[iz+i];
s[2] += g30[ix+i] * g0[iy+i] * g1[iz+i];
s[3] += g29[ix+i] * g2[iy+i] * g0[iz+i];
s[4] += g28[ix+i] * g3[iy+i] * g0[iz+i];
s[5] += g28[ix+i] * g2[iy+i] * g1[iz+i];
s[6] += g29[ix+i] * g0[iy+i] * g2[iz+i];
s[7] += g28[ix+i] * g1[iy+i] * g2[iz+i];
s[8] += g28[ix+i] * g0[iy+i] * g3[iz+i];
s[9] += g27[ix+i] * g4[iy+i] * g0[iz+i];
s[10] += g26[ix+i] * g5[iy+i] * g0[iz+i];
s[11] += g26[ix+i] * g4[iy+i] * g1[iz+i];
s[12] += g25[ix+i] * g6[iy+i] * g0[iz+i];
s[13] += g24[ix+i] * g7[iy+i] * g0[iz+i];
s[14] += g24[ix+i] * g6[iy+i] * g1[iz+i];
s[15] += g25[ix+i] * g4[iy+i] * g2[iz+i];
s[16] += g24[ix+i] * g5[iy+i] * g2[iz+i];
s[17] += g24[ix+i] * g4[iy+i] * g3[iz+i];
s[18] += g27[ix+i] * g0[iy+i] * g4[iz+i];
s[19] += g26[ix+i] * g1[iy+i] * g4[iz+i];
s[20] += g26[ix+i] * g0[iy+i] * g5[iz+i];
s[21] += g25[ix+i] * g2[iy+i] * g4[iz+i];
s[22] += g24[ix+i] * g3[iy+i] * g4[iz+i];
s[23] += g24[ix+i] * g2[iy+i] * g5[iz+i];
s[24] += g25[ix+i] * g0[iy+i] * g6[iz+i];
s[25] += g24[ix+i] * g1[iy+i] * g6[iz+i];
s[26] += g24[ix+i] * g0[iy+i] * g7[iz+i];
s[27] += g23[ix+i] * g8[iy+i] * g0[iz+i];
s[28] += g22[ix+i] * g9[iy+i] * g0[iz+i];
s[29] += g22[ix+i] * g8[iy+i] * g1[iz+i];
s[30] += g21[ix+i] * g10[iy+i] * g0[iz+i];
s[31] += g20[ix+i] * g11[iy+i] * g0[iz+i];
s[32] += g20[ix+i] * g10[iy+i] * g1[iz+i];
s[33] += g21[ix+i] * g8[iy+i] * g2[iz+i];
s[34] += g20[ix+i] * g9[iy+i] * g2[iz+i];
s[35] += g20[ix+i] * g8[iy+i] * g3[iz+i];
s[36] += g19[ix+i] * g12[iy+i] * g0[iz+i];
s[37] += g18[ix+i] * g13[iy+i] * g0[iz+i];
s[38] += g18[ix+i] * g12[iy+i] * g1[iz+i];
s[39] += g17[ix+i] * g14[iy+i] * g0[iz+i];
s[40] += g16[ix+i] * g15[iy+i] * g0[iz+i];
s[41] += g16[ix+i] * g14[iy+i] * g1[iz+i];
s[42] += g17[ix+i] * g12[iy+i] * g2[iz+i];
s[43] += g16[ix+i] * g13[iy+i] * g2[iz+i];
s[44] += g16[ix+i] * g12[iy+i] * g3[iz+i];
s[45] += g19[ix+i] * g8[iy+i] * g4[iz+i];
s[46] += g18[ix+i] * g9[iy+i] * g4[iz+i];
s[47] += g18[ix+i] * g8[iy+i] * g5[iz+i];
s[48] += g17[ix+i] * g10[iy+i] * g4[iz+i];
s[49] += g16[ix+i] * g11[iy+i] * g4[iz+i];
s[50] += g16[ix+i] * g10[iy+i] * g5[iz+i];
s[51] += g17[ix+i] * g8[iy+i] * g6[iz+i];
s[52] += g16[ix+i] * g9[iy+i] * g6[iz+i];
s[53] += g16[ix+i] * g8[iy+i] * g7[iz+i];
s[54] += g23[ix+i] * g0[iy+i] * g8[iz+i];
s[55] += g22[ix+i] * g1[iy+i] * g8[iz+i];
s[56] += g22[ix+i] * g0[iy+i] * g9[iz+i];
s[57] += g21[ix+i] * g2[iy+i] * g8[iz+i];
s[58] += g20[ix+i] * g3[iy+i] * g8[iz+i];
s[59] += g20[ix+i] * g2[iy+i] * g9[iz+i];
s[60] += g21[ix+i] * g0[iy+i] * g10[iz+i];
s[61] += g20[ix+i] * g1[iy+i] * g10[iz+i];
s[62] += g20[ix+i] * g0[iy+i] * g11[iz+i];
s[63] += g19[ix+i] * g4[iy+i] * g8[iz+i];
s[64] += g18[ix+i] * g5[iy+i] * g8[iz+i];
s[65] += g18[ix+i] * g4[iy+i] * g9[iz+i];
s[66] += g17[ix+i] * g6[iy+i] * g8[iz+i];
s[67] += g16[ix+i] * g7[iy+i] * g8[iz+i];
s[68] += g16[ix+i] * g6[iy+i] * g9[iz+i];
s[69] += g17[ix+i] * g4[iy+i] * g10[iz+i];
s[70] += g16[ix+i] * g5[iy+i] * g10[iz+i];
s[71] += g16[ix+i] * g4[iy+i] * g11[iz+i];
s[72] += g19[ix+i] * g0[iy+i] * g12[iz+i];
s[73] += g18[ix+i] * g1[iy+i] * g12[iz+i];
s[74] += g18[ix+i] * g0[iy+i] * g13[iz+i];
s[75] += g17[ix+i] * g2[iy+i] * g12[iz+i];
s[76] += g16[ix+i] * g3[iy+i] * g12[iz+i];
s[77] += g16[ix+i] * g2[iy+i] * g13[iz+i];
s[78] += g17[ix+i] * g0[iy+i] * g14[iz+i];
s[79] += g16[ix+i] * g1[iy+i] * g14[iz+i];
s[80] += g16[ix+i] * g0[iy+i] * g15[iz+i];
s[81] += g15[ix+i] * g16[iy+i] * g0[iz+i];
s[82] += g14[ix+i] * g17[iy+i] * g0[iz+i];
s[83] += g14[ix+i] * g16[iy+i] * g1[iz+i];
s[84] += g13[ix+i] * g18[iy+i] * g0[iz+i];
s[85] += g12[ix+i] * g19[iy+i] * g0[iz+i];
s[86] += g12[ix+i] * g18[iy+i] * g1[iz+i];
s[87] += g13[ix+i] * g16[iy+i] * g2[iz+i];
s[88] += g12[ix+i] * g17[iy+i] * g2[iz+i];
s[89] += g12[ix+i] * g16[iy+i] * g3[iz+i];
s[90] += g11[ix+i] * g20[iy+i] * g0[iz+i];
s[91] += g10[ix+i] * g21[iy+i] * g0[iz+i];
s[92] += g10[ix+i] * g20[iy+i] * g1[iz+i];
s[93] += g9[ix+i] * g22[iy+i] * g0[iz+i];
s[94] += g8[ix+i] * g23[iy+i] * g0[iz+i];
s[95] += g8[ix+i] * g22[iy+i] * g1[iz+i];
s[96] += g9[ix+i] * g20[iy+i] * g2[iz+i];
s[97] += g8[ix+i] * g21[iy+i] * g2[iz+i];
s[98] += g8[ix+i] * g20[iy+i] * g3[iz+i];
s[99] += g11[ix+i] * g16[iy+i] * g4[iz+i];
s[100] += g10[ix+i] * g17[iy+i] * g4[iz+i];
s[101] += g10[ix+i] * g16[iy+i] * g5[iz+i];
s[102] += g9[ix+i] * g18[iy+i] * g4[iz+i];
s[103] += g8[ix+i] * g19[iy+i] * g4[iz+i];
s[104] += g8[ix+i] * g18[iy+i] * g5[iz+i];
s[105] += g9[ix+i] * g16[iy+i] * g6[iz+i];
s[106] += g8[ix+i] * g17[iy+i] * g6[iz+i];
s[107] += g8[ix+i] * g16[iy+i] * g7[iz+i];
s[108] += g7[ix+i] * g24[iy+i] * g0[iz+i];
s[109] += g6[ix+i] * g25[iy+i] * g0[iz+i];
s[110] += g6[ix+i] * g24[iy+i] * g1[iz+i];
s[111] += g5[ix+i] * g26[iy+i] * g0[iz+i];
s[112] += g4[ix+i] * g27[iy+i] * g0[iz+i];
s[113] += g4[ix+i] * g26[iy+i] * g1[iz+i];
s[114] += g5[ix+i] * g24[iy+i] * g2[iz+i];
s[115] += g4[ix+i] * g25[iy+i] * g2[iz+i];
s[116] += g4[ix+i] * g24[iy+i] * g3[iz+i];
s[117] += g3[ix+i] * g28[iy+i] * g0[iz+i];
s[118] += g2[ix+i] * g29[iy+i] * g0[iz+i];
s[119] += g2[ix+i] * g28[iy+i] * g1[iz+i];
s[120] += g1[ix+i] * g30[iy+i] * g0[iz+i];
s[121] += g0[ix+i] * g31[iy+i] * g0[iz+i];
s[122] += g0[ix+i] * g30[iy+i] * g1[iz+i];
s[123] += g1[ix+i] * g28[iy+i] * g2[iz+i];
s[124] += g0[ix+i] * g29[iy+i] * g2[iz+i];
s[125] += g0[ix+i] * g28[iy+i] * g3[iz+i];
s[126] += g3[ix+i] * g24[iy+i] * g4[iz+i];
s[127] += g2[ix+i] * g25[iy+i] * g4[iz+i];
s[128] += g2[ix+i] * g24[iy+i] * g5[iz+i];
s[129] += g1[ix+i] * g26[iy+i] * g4[iz+i];
s[130] += g0[ix+i] * g27[iy+i] * g4[iz+i];
s[131] += g0[ix+i] * g26[iy+i] * g5[iz+i];
s[132] += g1[ix+i] * g24[iy+i] * g6[iz+i];
s[133] += g0[ix+i] * g25[iy+i] * g6[iz+i];
s[134] += g0[ix+i] * g24[iy+i] * g7[iz+i];
s[135] += g7[ix+i] * g16[iy+i] * g8[iz+i];
s[136] += g6[ix+i] * g17[iy+i] * g8[iz+i];
s[137] += g6[ix+i] * g16[iy+i] * g9[iz+i];
s[138] += g5[ix+i] * g18[iy+i] * g8[iz+i];
s[139] += g4[ix+i] * g19[iy+i] * g8[iz+i];
s[140] += g4[ix+i] * g18[iy+i] * g9[iz+i];
s[141] += g5[ix+i] * g16[iy+i] * g10[iz+i];
s[142] += g4[ix+i] * g17[iy+i] * g10[iz+i];
s[143] += g4[ix+i] * g16[iy+i] * g11[iz+i];
s[144] += g3[ix+i] * g20[iy+i] * g8[iz+i];
s[145] += g2[ix+i] * g21[iy+i] * g8[iz+i];
s[146] += g2[ix+i] * g20[iy+i] * g9[iz+i];
s[147] += g1[ix+i] * g22[iy+i] * g8[iz+i];
s[148] += g0[ix+i] * g23[iy+i] * g8[iz+i];
s[149] += g0[ix+i] * g22[iy+i] * g9[iz+i];
s[150] += g1[ix+i] * g20[iy+i] * g10[iz+i];
s[151] += g0[ix+i] * g21[iy+i] * g10[iz+i];
s[152] += g0[ix+i] * g20[iy+i] * g11[iz+i];
s[153] += g3[ix+i] * g16[iy+i] * g12[iz+i];
s[154] += g2[ix+i] * g17[iy+i] * g12[iz+i];
s[155] += g2[ix+i] * g16[iy+i] * g13[iz+i];
s[156] += g1[ix+i] * g18[iy+i] * g12[iz+i];
s[157] += g0[ix+i] * g19[iy+i] * g12[iz+i];
s[158] += g0[ix+i] * g18[iy+i] * g13[iz+i];
s[159] += g1[ix+i] * g16[iy+i] * g14[iz+i];
s[160] += g0[ix+i] * g17[iy+i] * g14[iz+i];
s[161] += g0[ix+i] * g16[iy+i] * g15[iz+i];
s[162] += g15[ix+i] * g0[iy+i] * g16[iz+i];
s[163] += g14[ix+i] * g1[iy+i] * g16[iz+i];
s[164] += g14[ix+i] * g0[iy+i] * g17[iz+i];
s[165] += g13[ix+i] * g2[iy+i] * g16[iz+i];
s[166] += g12[ix+i] * g3[iy+i] * g16[iz+i];
s[167] += g12[ix+i] * g2[iy+i] * g17[iz+i];
s[168] += g13[ix+i] * g0[iy+i] * g18[iz+i];
s[169] += g12[ix+i] * g1[iy+i] * g18[iz+i];
s[170] += g12[ix+i] * g0[iy+i] * g19[iz+i];
s[171] += g11[ix+i] * g4[iy+i] * g16[iz+i];
s[172] += g10[ix+i] * g5[iy+i] * g16[iz+i];
s[173] += g10[ix+i] * g4[iy+i] * g17[iz+i];
s[174] += g9[ix+i] * g6[iy+i] * g16[iz+i];
s[175] += g8[ix+i] * g7[iy+i] * g16[iz+i];
s[176] += g8[ix+i] * g6[iy+i] * g17[iz+i];
s[177] += g9[ix+i] * g4[iy+i] * g18[iz+i];
s[178] += g8[ix+i] * g5[iy+i] * g18[iz+i];
s[179] += g8[ix+i] * g4[iy+i] * g19[iz+i];
s[180] += g11[ix+i] * g0[iy+i] * g20[iz+i];
s[181] += g10[ix+i] * g1[iy+i] * g20[iz+i];
s[182] += g10[ix+i] * g0[iy+i] * g21[iz+i];
s[183] += g9[ix+i] * g2[iy+i] * g20[iz+i];
s[184] += g8[ix+i] * g3[iy+i] * g20[iz+i];
s[185] += g8[ix+i] * g2[iy+i] * g21[iz+i];
s[186] += g9[ix+i] * g0[iy+i] * g22[iz+i];
s[187] += g8[ix+i] * g1[iy+i] * g22[iz+i];
s[188] += g8[ix+i] * g0[iy+i] * g23[iz+i];
s[189] += g7[ix+i] * g8[iy+i] * g16[iz+i];
s[190] += g6[ix+i] * g9[iy+i] * g16[iz+i];
s[191] += g6[ix+i] * g8[iy+i] * g17[iz+i];
s[192] += g5[ix+i] * g10[iy+i] * g16[iz+i];
s[193] += g4[ix+i] * g11[iy+i] * g16[iz+i];
s[194] += g4[ix+i] * g10[iy+i] * g17[iz+i];
s[195] += g5[ix+i] * g8[iy+i] * g18[iz+i];
s[196] += g4[ix+i] * g9[iy+i] * g18[iz+i];
s[197] += g4[ix+i] * g8[iy+i] * g19[iz+i];
s[198] += g3[ix+i] * g12[iy+i] * g16[iz+i];
s[199] += g2[ix+i] * g13[iy+i] * g16[iz+i];
s[200] += g2[ix+i] * g12[iy+i] * g17[iz+i];
s[201] += g1[ix+i] * g14[iy+i] * g16[iz+i];
s[202] += g0[ix+i] * g15[iy+i] * g16[iz+i];
s[203] += g0[ix+i] * g14[iy+i] * g17[iz+i];
s[204] += g1[ix+i] * g12[iy+i] * g18[iz+i];
s[205] += g0[ix+i] * g13[iy+i] * g18[iz+i];
s[206] += g0[ix+i] * g12[iy+i] * g19[iz+i];
s[207] += g3[ix+i] * g8[iy+i] * g20[iz+i];
s[208] += g2[ix+i] * g9[iy+i] * g20[iz+i];
s[209] += g2[ix+i] * g8[iy+i] * g21[iz+i];
s[210] += g1[ix+i] * g10[iy+i] * g20[iz+i];
s[211] += g0[ix+i] * g11[iy+i] * g20[iz+i];
s[212] += g0[ix+i] * g10[iy+i] * g21[iz+i];
s[213] += g1[ix+i] * g8[iy+i] * g22[iz+i];
s[214] += g0[ix+i] * g9[iy+i] * g22[iz+i];
s[215] += g0[ix+i] * g8[iy+i] * g23[iz+i];
s[216] += g7[ix+i] * g0[iy+i] * g24[iz+i];
s[217] += g6[ix+i] * g1[iy+i] * g24[iz+i];
s[218] += g6[ix+i] * g0[iy+i] * g25[iz+i];
s[219] += g5[ix+i] * g2[iy+i] * g24[iz+i];
s[220] += g4[ix+i] * g3[iy+i] * g24[iz+i];
s[221] += g4[ix+i] * g2[iy+i] * g25[iz+i];
s[222] += g5[ix+i] * g0[iy+i] * g26[iz+i];
s[223] += g4[ix+i] * g1[iy+i] * g26[iz+i];
s[224] += g4[ix+i] * g0[iy+i] * g27[iz+i];
s[225] += g3[ix+i] * g4[iy+i] * g24[iz+i];
s[226] += g2[ix+i] * g5[iy+i] * g24[iz+i];
s[227] += g2[ix+i] * g4[iy+i] * g25[iz+i];
s[228] += g1[ix+i] * g6[iy+i] * g24[iz+i];
s[229] += g0[ix+i] * g7[iy+i] * g24[iz+i];
s[230] += g0[ix+i] * g6[iy+i] * g25[iz+i];
s[231] += g1[ix+i] * g4[iy+i] * g26[iz+i];
s[232] += g0[ix+i] * g5[iy+i] * g26[iz+i];
s[233] += g0[ix+i] * g4[iy+i] * g27[iz+i];
s[234] += g3[ix+i] * g0[iy+i] * g28[iz+i];
s[235] += g2[ix+i] * g1[iy+i] * g28[iz+i];
s[236] += g2[ix+i] * g0[iy+i] * g29[iz+i];
s[237] += g1[ix+i] * g2[iy+i] * g28[iz+i];
s[238] += g0[ix+i] * g3[iy+i] * g28[iz+i];
s[239] += g0[ix+i] * g2[iy+i] * g29[iz+i];
s[240] += g1[ix+i] * g0[iy+i] * g30[iz+i];
s[241] += g0[ix+i] * g1[iy+i] * g30[iz+i];
s[242] += g0[ix+i] * g0[iy+i] * g31[iz+i];
}
gout[n*48+0] = + s[104] - s[176] - s[106] + s[178];
gout[n*48+1] = + s[167] - s[23] - s[169] + s[25];
gout[n*48+2] = + s[14] - s[86] - s[16] + s[88];
gout[n*48+3] = + s[5] + s[95] + s[185] - s[7] - s[97] - s[187];
gout[n*48+4] = + s[105] - s[177] - s[101] + s[173];
gout[n*48+5] = + s[168] - s[24] - s[164] + s[20];
gout[n*48+6] = + s[15] - s[87] - s[11] + s[83];
gout[n*48+7] = + s[6] + s[96] + s[186] - s[2] - s[92] - s[182];
gout[n*48+8] = + s[100] - s[172] - s[102] + s[174];
gout[n*48+9] = + s[163] - s[19] - s[165] + s[21];
gout[n*48+10] = + s[10] - s[82] - s[12] + s[84];
gout[n*48+11] = + s[1] + s[91] + s[181] - s[3] - s[93] - s[183];
gout[n*48+12] = + s[99] - s[171] + s[103] - s[175] + s[107] - s[179];
gout[n*48+13] = + s[162] - s[18] + s[166] - s[22] + s[170] - s[26];
gout[n*48+14] = + s[9] - s[81] + s[13] - s[85] + s[17] - s[89];
gout[n*48+15] = + s[0] + s[90] + s[180] + s[4] + s[94] + s[184] + s[8] + s[98] + s[188];
gout[n*48+16] = + s[131] - s[203] - s[133] + s[205];
gout[n*48+17] = + s[194] - s[50] - s[196] + s[52];
gout[n*48+18] = + s[41] - s[113] - s[43] + s[115];
gout[n*48+19] = + s[32] + s[122] + s[212] - s[34] - s[124] - s[214];
gout[n*48+20] = + s[132] - s[204] - s[128] + s[200];
gout[n*48+21] = + s[195] - s[51] - s[191] + s[47];
gout[n*48+22] = + s[42] - s[114] - s[38] + s[110];
gout[n*48+23] = + s[33] + s[123] + s[213] - s[29] - s[119] - s[209];
gout[n*48+24] = + s[127] - s[199] - s[129] + s[201];
gout[n*48+25] = + s[190] - s[46] - s[192] + s[48];
gout[n*48+26] = + s[37] - s[109] - s[39] + s[111];
gout[n*48+27] = + s[28] + s[118] + s[208] - s[30] - s[120] - s[210];
gout[n*48+28] = + s[126] - s[198] + s[130] - s[202] + s[134] - s[206];
gout[n*48+29] = + s[189] - s[45] + s[193] - s[49] + s[197] - s[53];
gout[n*48+30] = + s[36] - s[108] + s[40] - s[112] + s[44] - s[116];
gout[n*48+31] = + s[27] + s[117] + s[207] + s[31] + s[121] + s[211] + s[35] + s[125] + s[215];
gout[n*48+32] = + s[158] - s[230] - s[160] + s[232];
gout[n*48+33] = + s[221] - s[77] - s[223] + s[79];
gout[n*48+34] = + s[68] - s[140] - s[70] + s[142];
gout[n*48+35] = + s[59] + s[149] + s[239] - s[61] - s[151] - s[241];
gout[n*48+36] = + s[159] - s[231] - s[155] + s[227];
gout[n*48+37] = + s[222] - s[78] - s[218] + s[74];
gout[n*48+38] = + s[69] - s[141] - s[65] + s[137];
gout[n*48+39] = + s[60] + s[150] + s[240] - s[56] - s[146] - s[236];
gout[n*48+40] = + s[154] - s[226] - s[156] + s[228];
gout[n*48+41] = + s[217] - s[73] - s[219] + s[75];
gout[n*48+42] = + s[64] - s[136] - s[66] + s[138];
gout[n*48+43] = + s[55] + s[145] + s[235] - s[57] - s[147] - s[237];
gout[n*48+44] = + s[153] - s[225] + s[157] - s[229] + s[161] - s[233];
gout[n*48+45] = + s[216] - s[72] + s[220] - s[76] + s[224] - s[80];
gout[n*48+46] = + s[63] - s[135] + s[67] - s[139] + s[71] - s[143];
gout[n*48+47] = + s[54] + s[144] + s[234] + s[58] + s[148] + s[238] + s[62] + s[152] + s[242];
}}
void int2e_ipsrsr1srsr2_optimizer(CINTOpt **opt, int *atm, int natm, int *bas, int nbas, double *env) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTall_2e_optimizer(opt, ng, atm, natm, bas, nbas, env);
}
int int2e_ipsrsr1srsr2_cart(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipsrsr1srsr2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipsrsr1srsr2_simd1;
return CINT2e_cart_drv(out, dims, &envs, opt, cache);
} // int2e_ipsrsr1srsr2_cart
int int2e_ipsrsr1srsr2_sph(double *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipsrsr1srsr2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipsrsr1srsr2_simd1;
return CINT2e_spheric_drv(out, dims, &envs, opt, cache);
} // int2e_ipsrsr1srsr2_sph
int int2e_ipsrsr1srsr2_spinor(double complex *out, int *dims, int *shls,
int *atm, int natm, int *bas, int nbas, double *env, CINTOpt *opt, double *cache) {
int ng[] = {2, 1, 1, 1, 5, 4, 4, 3};
CINTEnvVars envs;
CINTinit_int2e_EnvVars(&envs, ng, shls, atm, natm, bas, nbas, env);
envs.f_gout = &CINTgout2e_int2e_ipsrsr1srsr2;
envs.f_gout_simd1 = &CINTgout2e_int2e_ipsrsr1srsr2_simd1;
return CINT2e_spinor_drv(out, dims, &envs, opt, cache, &c2s_si_2e1, &c2s_si_2e2);
} // int2e_ipsrsr1srsr2_spinor
ALL_CINT(int2e_ipsrsr1srsr2)
//ALL_CINT_FORTRAN_(cint2e_ipsrsr1srsr2)
